{**********************************************************}
{                                                          }
{                   Projet SoftOptique                     }
{              Gestion des lments optiques               }
{                                                          }
{   Txxxxx   : L'lment optique                           }
{   TxxxPlus : L'outil associ                             }
{   TxxxInfo : La bote de dialogue (prive)               }
{ o xxxxx vaut :                                          }
{   Element : Type abstrait d'lment optique              }
{   Lentill : Lentille                                     }
{   Miroir  : Miroir Plan ou sphrique                     }
{   Diaph   : Diaphragme                                   }
{   Pupil   : Pupille d'entre du systme                  }
{   Bougie  : Objet                                        }
{                                                          }
{   Debut du projet : 10.04.93                   cm0=200   }
{   Mise A Jour     : 09.05.93                             }
{                                                          }
{**********************************************************}

UNIT Elements;

INTERFACE

Uses Disk,Drivers,ObjetAbs,Objet;

Const
     cmElements   = 200;
     cmLentilInfo = cmElements+00;
     cmMiroirInfo = cmElements+01;
     cmDiaphInfo  = cmElements+02;

Type PElement = ^TElement;
     PLentill = ^TLentill;
     PLenPlus = ^TLenPlus;
     PMiroir  = ^TMiroir;
     PMirPlus = ^TMirPlus;
     PDiaph   = ^TDiaph;
     PDiaPlus = ^TDiaPlus;
     PPupil   = ^TPupil;
     PBougie  = ^TBougie;
     TElement = Object(TObjet)
                  PosX  : Real;
                  Diam  : Real;
                  Color : Byte;
                  Constructor Init(eX,eD : Real ; eC : Byte);
                  Procedure   Draw;                                  Virtual;
                  Procedure   DrawSelect;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   Write(F : PDisk);                      Virtual;
                  Procedure   Read(F : PDisk);                       Virtual;
                  Procedure   ElementClic;                           Virtual;
                  Procedure   Conjugue(Var R : TRay ; BL : Boolean); Virtual;
                End;
     TLentill = Object(TElement)
                  Focale : Real;
                  Foyers : Boolean;
                  Nu     : Real;
                  Constructor Init(eX,eD,eF,eNu : Real ; eC : Byte ; Foy : Boolean);
                  Procedure   Draw;                                  Virtual;
                  Procedure   Write(F : PDisk);                      Virtual;
                  Procedure   Read(F : PDisk);                       Virtual;
                  Procedure   ElementClic;                           Virtual;
                  Procedure   Conjugue(Var R : TRay ; BL : Boolean); Virtual;
                End;
     TLenPlus = Object(TOutil)
                  Constructor Init(X,Y : Integer);
                  Procedure   WrkZoneClic(P : TPoint);               Virtual;
                End;
     TMiroir  = Object(TElement)
                  Courbure : Real;
                  Centre   : Boolean;
                  Constructor Init(eX,eD,eCo : Real ; eC : Byte ; eCen : Boolean);
                  Procedure   Draw;                                  Virtual;
                  Procedure   Write(F : PDisk);                      Virtual;
                  Procedure   Read(F : PDisk);                       Virtual;
                  Procedure   ElementClic;                           Virtual;
                  Procedure   Conjugue(Var R : TRay ; BL : Boolean); Virtual;
                End;
     TMirPlus = Object(TOutil)
                  Constructor Init(X,Y : Integer);
                  Procedure   WrkZoneClic(P : TPoint);               Virtual;
                End;
     TDiaph   = Object(TElement)
                  Constructor Init(eX,eD : Real ; eC : Byte);
                  Procedure   Draw;                                  Virtual;
                  Procedure   ElementClic;                           Virtual;
                End;
     TDiaPlus = Object(TOutil)
                  Constructor Init(X,Y : Integer);
                  Procedure   WrkZoneClic(P : TPoint);               Virtual;
                End;
     TPupil   = Object(TDiaph)
                  Constructor Init(eX,eD : Real);
                  Procedure   Draw;                                  Virtual;
                End;
     TBougie  = Object(TElement)
                  Angle : Real;
                  Tpe   : Byte;
                  Constructor Init(eX,eD,eA : Real ; eTpe : Byte);
                  Procedure   Draw;                                  Virtual;
                  Procedure   Write(F : PDisk);                      Virtual;
                  Procedure   Read(F : PDisk);                       Virtual;
                  Procedure   ElementClic;                           Virtual;
                End;

Var Diap  : Boolean;
    Sens  : Boolean;

Procedure LentilInfo;
Procedure MiroirInfo;
Procedure DiaphInfo;

IMPLEMENTATION

Uses Graph,Outils;

Type PLenInfo = ^TLenInfo;
     TLenRec  = Record
                  Focale   : Real;
                  Diametre : Real;
                  Position : Real;
                  Nu       : Real;
                  Couleur  : Byte;
                  Foyers   : Boolean;
                End;
     TLenInfo = Object(TDialog)
                  Constructor Init(Creer : Boolean ; T : String);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     PMirInfo = ^TMirInfo;
     TMirInfo = Object(TDialog)
                  Constructor Init(Creer : Boolean ; T : String);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TMirRec  = Record
                  Courbure : Real;
                  Diametre : Real;
                  Position : Real;
                  Couleur  : Byte;
                  Centre   : Boolean;
                End;
     PDiaInfo = ^TDiaInfo;
     TDiaInfo = Object(TDialog)
                  Constructor Init(Creer : Boolean ; T : String );
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TDiaRec  = Record
                  Diametre : Real;
                  Position : Real;
                  Couleur  : Byte;
                End;
     PBouInfo = ^TBouInfo;
     TBouInfo = Object(TDialog)
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TBouRec  = Record
                  Position : Real;
                  Hauteur  : Real;
                  Angle    : Real;
                  Tpe      : Byte;
                End;

Procedure VerifData(Var D : TLenRec);
Begin
  If D.Focale=0 Then D.Focale:=0.000001;
  If D.Nu=1 THen D.Nu:=1.000001;
End;

{ ==== Module : Element optique ==== }

Constructor TElement.Init(eX,eD : Real ; eC : Byte);
Begin
  inherited Init(0,0,0,0,0);
  PosX:=eX;
  Diam:=eD;
  Color:=eC;
End;

Procedure TElement.DrawSelect;
Var P : TPoint;
Begin
  if (Etat AND stVisible)<>0 Then
    if (Etat AND stSelected)<>0 Then
    Begin
      DrawBegin;
      MakeGlobal(Origin,P);
      SetLineStyle(DottedLn,0,1);
      SetWriteMode(XORPut);
      SetColor(15);
      Rectangle(P.X,P.Y,P.X+Size.X-1,P.Y+Size.Y-1);
      SetWriteMode(NormalPut);
      SetLineStyle(SolidLn,0,1);
      DrawEnd;
    End;
End;

Procedure TElement.Draw;
Begin
  If (PosX>=Zooms^.X1) AND (PosX<=Zooms^.X2)
  Then
    Begin
      Origin.X:=EX(PosX)-10-WrkZone^.Origin.X;
      Size.X:=20;
      If Diam/2>Zooms^.Y1 Then Origin.Y:=8
                          Else Origin.Y:=EY(Diam/2);
      If Origin.Y>=18 Then Origin.Y:=Origin.Y-10;
      Size.Y:=(EY(0)-Origin.Y)*2;
      Origin.Y:=Origin.Y-WrkZone^.Origin.Y;
      Etat:=Etat OR stVisible;
    End
  Else Etat:=Etat AND (Not (stVisible+stSelected));
End;

Procedure TElement.HandleEvent(Var Event : TEvent);
Begin
  MouseAspect:=WrkZone^.MouseAspect;
  inherited HandleEvent(Event);
  Case Event.What Of
    evMouseLDown : If (Etat AND stVisible)<>0 Then
                     If MouseInObjet Then Outil^.ElementClic(@Self,Event);
    evMouseRDown : If (Etat AND stVisible)<>0 Then
                     If MouseInObjet Then
                     Begin
                       ElementClic;
                       Event.What:=evNothing;
                     End;
  End;
End;

Procedure TElement.Write(F : PDisk);
Var S : String[11];
Begin
  S:=Ident;S:=Copy(S+'          ',1,10);
  S:=S+':';
  F^.Write(S[1],11);
  F^.Write(PosX,SizeOf(Real));
  F^.Write(Diam,SizeOf(Real));
  F^.Write(Color,SizeOf(Byte));
End;

Procedure TElement.Read(F : PDisk);
Begin
  F^.Read(PosX,SizeOf(Real));
  F^.Read(Diam,SizeOf(Real));
  F^.Read(Color,SizeOf(Byte));
End;

Procedure TElement.ElementClic;
Begin
End;

Procedure TElement.Conjugue(Var R : TRay ; BL : Boolean);
Begin
  If Abs(R.Y)>Diam/2 Then Diap:=TRUE;
End;

{ ==== Module : Lentille ==== }

Var LentilFoc  : Real;
    LentilDiam : Real;
    LentilCoul : Byte;
    LentilFoy  : Boolean;
    LentilNu   : Real;

{ --- Element : TLentill --- }

Constructor TLentill.Init(eX,eD,eF,eNu : Real ; eC : Byte ; Foy : Boolean);
Begin
  inherited Init(eX,eD,eC);
  Ident:='Lentille';
  HelpCtx:='Lentille';
  Focale:=eF;
  If Focale=0 Then Focale:=0.01;
  Foyers:=Foy;
  Nu:=eNu;
End;

Procedure TLentill.Draw;
Var P : TPoint;
    X : Real;
  Procedure AffFoyer(Nom : String);
  Begin
    If (X<Zooms^.X1) OR (X>Zooms^.X2) Then Exit;
    P.X:=EX(X);
    P.Y:=EY(0);
    Line(P.X-2,P.Y-2,P.X+2,P.Y+2);
    Line(P.X-2,P.Y+2,P.X+2,P.Y-2);
    OutTextXY(P.X-4,P.Y-9,Nom);
  End;
Begin
  inherited Draw;
  If (Etat AND stVisible)<>0 Then
  Begin
    DrawBegin;
    MakeGlobal(Origin,P);
    SetColor(Color);
    If Focale>0
    Then
      Begin
        Line(P.X+10,P.Y+10,P.X+10,P.Y+Size.Y-1-10);
        Line(P.X+10,P.Y+Size.Y-1-10,P.X+10-4,P.Y+Size.Y-1-4-10);
        Line(P.X+10,P.Y+Size.Y-1-10,P.X+10+4,P.Y+Size.Y-1-4-10);
        Line(P.X+10,P.Y+10,P.X+10-4,P.Y+4+10);
        Line(P.X+10,P.Y+10,P.X+10+4,P.Y+4+10);
      End
    Else
      Begin
        Line(P.X+10,P.Y+10,P.X+10,P.Y+Size.Y-1-10);
        Line(P.X+10,P.Y+Size.Y-1-10,P.X+10-4,P.Y+Size.Y-1+4-10);
        Line(P.X+10,P.Y+Size.Y-1-10,P.X+10+4,P.Y+Size.Y-1+4-10);
        Line(P.X+10,P.Y+10,P.X+10-4,P.Y-4+10);
        Line(P.X+10,P.Y+10,P.X+10+4,P.Y-4+10);
      End;
    If Foyers Then
    Begin
      X:=PosX-Focale;
      AffFoyer('F');
      X:=PosX+Focale;
      AffFoyer('F''');
    End;
    DrawEnd;
  End;
End;

Procedure TLentill.Write(F : PDisk);
Begin
  inherited Write(F);
  F^.Write(Focale,SizeOf(Real));
  F^.Write(Nu,SizeOf(Real));
  F^.Write(Foyers,SizeOf(Boolean));
End;

Procedure TLentill.Read(F : PDisk);
Begin
  inherited Read(F);
  F^.Read(Focale,SizeOf(Real));
  F^.Read(Nu,SizeOf(Real));
  F^.Read(Foyers,SizeOf(Boolean));
End;

Procedure TLentill.ElementClic;
Var D : PLenInfo;
    R : TLenRec;
Begin
  D:=New(PLenInfo,Init(FALSE,'Paramtres d''une lentille'));
  R.Focale:=Focale;
  R.Diametre:=Diam;
  R.Position:=PosX;
  R.Nu:=Nu;
  R.Couleur:=Color;
  R.Foyers:=Foyers;
  D^.SetData(R);
  Application^.Insert(D);
  If D^.Exec=exOK Then
  Begin
    D^.GetData(R);
    Focale:=R.Focale;
    Diam:=R.Diametre;
    PosX:=R.Position;
    Nu:=R.Nu;
    Color:=R.Couleur;
    Foyers:=R.Foyers;
    WrkZone^.Draw;
  End;
  Dispose(D,Done);
End;

Procedure TLentill.Conjugue(Var R : TRay ; BL : Boolean);
Var F : Real;
Begin
  inherited Conjugue(R,BL);                    { Vrifie Diaphragme          }
  F:=Focale;
  If BL Then F:=F*(1-1/Nu);                    { Chromatisme de la focale    }
  If Sens Then R.A:=R.A-R.Y*(1/F)              { Applique la dviation D=-hC }
          Else R.A:=R.A+R.Y*(1/F);
End;

{ ---- Outil : TLenPlus ---- }

Constructor TLenPlus.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,icLentil,cmLentilInfo,#0,#38,'Ajout d''une lentille','Alt-L');
  HelpCtx:='Lentille (Outil)';
  OutilAspect:=MouseLentil;
  LentilFoc:=200;
  LentilDiam:=50;
  LentilCoul:=11;
  LentilNu:=50;
End;

Procedure TLenPlus.WrkZoneClic(P : TPoint);
Var X : Real;
Begin
  X:=RX(P.X);
  WrkZone^.Insert(New(PLentill,Init(X,LentilDiam,LentilFoc,LentilNu,
                                    LentilCoul,LentilFoy)));
  WrkZone^.Draw;
  Modif:=TRUE;
  SetCommand(cmModif);
End;

{ ---- Info : TLenInfo ---- }

Constructor TLenInfo.Init(Creer : Boolean ; T : String);
Var E : PEdit;
Begin
  inherited Init(50,50,327,156,T);
  Ident:='DIA:LENTIL';
  HelpCtx:='Lentille (Dialogue)';
  If Creer Then
    Insert(New(PButton,Init(134,129,cmNew,'Crer',0,#0,#0)));
  Insert(New(PButton,Init(192,129,cmOK,'OK',btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(240,129,cmAnnule,'Annuler',btMotifEsc,#27,#0)));
  Insert(New(PIcone2,Init(13,29,1)));
  E:=New(PReEdit,Init(190,26,15));
  Insert(E);
  Insert(New(PReEdit,Init(190,47,15)));
  Insert(New(PReEdit,Init(190,68,15)));
  Insert(New(PReEdit,Init(190,89,15)));
  Insert(New(PCoPalet,Init(9,86)));
  Insert(New(PCoche,Init(62,110)));
  E^.Select;
End;

Procedure TLenInfo.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+62,P.Y+30,'Focale        :');
  OutTextXY(P.X+62,P.Y+51,'Diamtre      :');
  OutTextXY(P.X+62,P.Y+72,'Position      :');
  OutTextXY(P.X+62,P.Y+93,'Constringence :');
  OutTextXY(P.X+80,P.Y+113,'Affiche les foyers');
  DrawEnd;
End;

Procedure TLenInfo.HandleEvent(Var Event : TEvent);
Var D : TLenRec;
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmOK     : ExitCode:=exOK;
      cmAnnule : ExitCode:=exAnnule;
      cmNew    : Begin
                   GetData(D);
                   VerifData(D);
                   WrkZone^.Insert(New(PLentill,
                   Init(D.Position,Abs(D.Diametre),D.Focale,D.Nu,D.Couleur,D.Foyers)));
                   RestitueEcran;
                   WrkZone^.Draw;
                   SauveEcran;
                   Draw;
                   Modif:=TRUE;
                   SetCommand(cmModif);
                 End;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

Procedure LentilInfo;
Var D : PLenInfo;
    L : TLenRec;
Begin
  L.Focale:=LentilFoc;
  L.Diametre:=LentilDiam;
  L.Nu:=LentilNu;
  L.Couleur:=LentilCoul;
  L.Position:=0;
  L.Foyers:=LentilFoy;
  D:=New(PLenInfo,Init(TRUE,'Paramtres des lentilles'));
  D^.SetData(L);
  Application^.Insert(D);
  If D^.Exec=exOK Then
  Begin
    D^.GetData(L);
    VerifData(L);
    LentilFoc:=L.Focale;
    LentilNu:=L.Nu;
    LentilCoul:=L.Couleur;
    LentilDiam:=Abs(L.Diametre);
    LentilFoy:=L.Foyers;
  End;
  Dispose(D,Done);
End;

{ ==== Module : Miroir ==== }

Var MiroirCour : Real;
    MiroirDiam : Real;
    MiroirCoul : Byte;
    MiroirCen  : Boolean;

{ ---- Element : TMiroir ---- }

Constructor TMiroir.Init(eX,eD,eCo : Real ; eC : Byte ; eCen : Boolean);
Begin
  inherited Init(eX,eD,eC);
  Ident:='Miroir';
  HelpCtx:='Miroir';
  Courbure:=eCo;
  Centre:=eCen;
End;

Procedure TMiroir.Draw;
Var P : TPoint;
  Procedure PlacePoint(X : Real ; L : Char);
  Begin
    If (X>Zooms^.X1) AND (X<Zooms^.X2) Then
    Begin
      P.X:=EX(X);
      P.Y:=EY(0);
      Line(P.X-2,P.Y-2,P.X+2,P.Y+2);
      Line(P.X-2,P.Y+2,P.X+2,P.Y-2);
      OutTextXY(P.X-4,P.Y-9,L);
    End;
  End;
Begin
  inherited Draw;
  If (Etat AND stVisible)<>0 Then
  Begin
    DrawBegin;
    MakeGlobal(Origin,P);
    SetColor(Color);
    Line(P.X+10,P.Y+10,P.X+10,P.Y+Size.Y-1-10);
    SetLineStyle(DottedLn,0,1);
    If Courbure=0 Then
    Begin
      Line(P.X+9,P.Y+10,P.X+9,P.Y+Size.Y-1-10);
      Line(P.X+11,P.Y+10,P.X+11,P.Y+Size.Y-1-10);
      SetLineStyle(SolidLn,0,1);
    End;
    If Courbure>0 Then
    Begin
      Line(P.X+9,P.Y+10,P.X+9,P.Y+Size.Y-1-10);
      SetLineStyle(SolidLn,0,1);
      Line(P.X+10,P.Y+Size.Y-1-10,P.X+10+4,P.Y+Size.Y-1+4-10);
      Line(P.X+10,P.Y+10,P.X+10+4,P.Y-4+10);
    End;
    If Courbure<0 Then
    Begin
      Line(P.X+11,P.Y+10,P.X+11,P.Y+Size.Y-1-10);
      SetLineStyle(SolidLn,0,1);
      Line(P.X+10,P.Y+Size.Y-1-10,P.X+10-4,P.Y+Size.Y-1+4-10);
      Line(P.X+10,P.Y+10,P.X+10-4,P.Y-4+10);
    End;
    If Centre AND (Courbure<>0) Then
    Begin
      PlacePoint(PosX+1/Courbure,'C');
      PlacePoint(PosX+0.5/Courbure,'F');
    End;
    DrawEnd;
  End;
End;

Procedure TMiroir.Write(F : PDisk);
Begin
  inherited Write(F);
  F^.Write(Courbure,SizeOf(Real));
  F^.Write(Centre,SizeOf(Boolean));
End;

Procedure TMiroir.Read(F : PDisk);
Begin
  inherited Read(F);
  F^.Read(Courbure,SizeOf(Real));
  F^.Read(Centre,SizeOf(Boolean));
End;

Procedure TMiroir.ElementClic;
Var D : PMirInfo;
    R : TMirRec;
Begin
  D:=New(PMirInfo,Init(FALSE,'Paramtres d''un miroir'));
  R.Courbure:=Courbure;
  R.Diametre:=Diam;
  R.Position:=PosX;
  R.Couleur:=Color;
  R.Centre:=Centre;
  D^.SetData(R);
  Application^.Insert(D);
  If D^.Exec=exOK Then
  Begin
    D^.GetData(R);
    Courbure:=R.Courbure;
    Diam:=R.Diametre;
    PosX:=R.Position;
    Color:=R.Couleur;
    Centre:=R.Centre;
    WrkZone^.Draw;
    Modif:=TRUE;
    SetCommand(cmModif);
  End;
  Dispose(D,Done);
End;

Procedure TMiroir.Conjugue(Var R : TRay ; BL : Boolean);
Var E : PObjet;
Begin
  inherited Conjugue(R,BL);                         { Vrifie diaphragme     }
  Sens:=Not Sens;
  R.A:=-R.Y*2*Courbure-R.A;                         { Conjugue               }
  E:=WrkZone^.Liste;                                { Autorise le passage    }
  While (E<>NIL) do                                 { Sur les lments       }
  Begin                                             { dj traverss par les }
    E^.Etat:=E^.Etat AND (Not stTraite);            { rayons lumineux        }
    E:=E^.Suiv;
  End;
End;

{ --- Outil : TMirPlus --- }

Constructor TMirPlus.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,icMiroir,cmMiroirInfo,#0,#50,'Ajout d''un miroir','Alt-M');
  OutilAspect:=MouseMiroir;
  HelpCtx:='Miroir (Outil)';
  MiroirCour:=-1/1000;
  MiroirDiam:=50;
  MiroirCoul:=11;
  MiroirCen:=FALSE;
End;

Procedure TMirPlus.WrkZoneClic(P : TPoint);
Var X : Real;
Begin
  X:=RX(P.X);
  WrkZone^.Insert(New(PMiroir,Init(X,MiroirDiam,MiroirCour,MiroirCoul,MiroirCen)));
  WrkZone^.Draw;
  Modif:=TRUE;
  SetCommand(cmModif);
End;

{ ---- Info : TMirInfo ---- }

Constructor TMirInfo.Init(Creer : Boolean ; T : String);
Var E : PEdit;
Begin
  inherited Init(50,50,287,141,T);
  Ident:='DIA:MIROIR';
  HelpCtx:='Miroir (Dialogue)';
  If Creer Then
    Insert(New(PButton,Init(94,114,cmNew,'Crer',0,#0,#0)));
  Insert(New(PButton,Init(152,114,cmOK,'OK',btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(200,114,cmAnnule,'Annuler',btMotifEsc,#27,#0)));
  Insert(New(PIcone2,Init(13,34,2)));
  E:=New(PReEdit,Init(150,26,15));
  Insert(E);
  Insert(New(PReEdit,Init(150,50,15)));
  Insert(New(PReEdit,Init(150,74,15)));
  Insert(New(PCoPalet,Init(9,87)));
  Insert(New(PCoche,Init(62,95)));
  E^.Select;
End;

Procedure TMirInfo.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+62,P.Y+30,'Courbure :');
  OutTextXY(P.X+62,P.Y+54,'Diamtre :');
  OutTextXY(P.X+62,P.Y+78,'Position :');
  OutTextXY(P.X+80,P.Y+98,'Affiche centre et foyer');
  DrawEnd;
End;

Procedure TMirInfo.HandleEvent(Var Event : TEvent);
Var D : TMirRec;
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmOK     : ExitCode:=exOK;
      cmAnnule : ExitCode:=exAnnule;
      cmNew    : Begin
                   GetData(D);
                   WrkZone^.Insert(New(PMiroir,
                   Init(D.Position,Abs(D.Diametre),D.Courbure,D.Couleur,D.Centre)));
                   RestitueEcran;
                   WrkZone^.Draw;
                   SauveEcran;
                   Draw;
                   Modif:=TRUE;
                   SetCommand(cmModif);
                 End;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

Procedure MiroirInfo;
Var D : PMirInfo;
    L : TMirRec;
Begin
  L.Courbure:=MiroirCour;
  L.Diametre:=MiroirDiam;
  L.Couleur:=MiroirCoul;
  L.Position:=0;
  L.Centre:=MiroirCen;
  D:=New(PMirInfo,Init(TRUE,'Paramtres des miroirs'));
  D^.SetData(L);
  Application^.Insert(D);
  If D^.Exec=exOK Then
  Begin
    D^.GetData(L);
    MiroirCour:=L.Courbure;
    MiroirCoul:=L.Couleur;
    MiroirDiam:=Abs(L.Diametre);
    MiroirCen:=L.Centre;
  End;
  Dispose(D,Done);
End;

{ ==== Module : Diaphragme ==== }

Var DiaphDiam : Real;
    DiaphCoul : Byte;

{ ---- Element : TDiaph ---- }

Constructor TDiaph.Init(eX,eD : Real ; eC : Byte);
Begin
  inherited Init(eX,eD,eC);
  Ident:='Diaphragme';
  HelpCtx:='Diaphragme';
End;

Procedure TDiaph.Draw;
Var P : TPoint;
Begin
  inherited Draw;
  If (Etat AND stVisible)<>0 Then
  Begin
    DrawBegin;
    MakeGlobal(Origin,P);
    SetColor(Color);
    Line(P.X+10,P.Y-4+10,P.X+10,P.Y+10);
    Line(P.X+6,P.Y+10,P.X+14,P.Y+10);
    Line(P.X+10,P.Y+Size.Y-1-10,P.X+10,P.Y+Size.Y-1+4-10);
    Line(P.X+6,P.Y+Size.Y-1-10,P.X+14,P.Y+Size.Y-1-10);
    SetLineStyle(DottedLn,0,1);
    Line(P.X+10,P.Y+10,P.X+10,P.Y+Size.Y-1-10);
    SetLineStyle(SolidLn,0,1);
    DrawEnd;
  End;
End;

Procedure TDiaph.ElementClic;
Var D : PDiaInfo;
    R : TDiaRec;
Begin
  If Ident='Pupille' Then D:=New(PDiaInfo,Init(FALSE,'Paramtres de la pupille'))
                     Else D:=New(PDiaInfo,Init(FALSE,'Paramtres d''un diaphragme'));
  R.Diametre:=Diam;
  R.Position:=PosX;
  R.Couleur:=Color;
  D^.SetData(R);
  Application^.Insert(D);
  If D^.Exec=exOK Then
  Begin
    D^.GetData(R);
    Diam:=R.Diametre;
    PosX:=R.Position;
    Color:=R.Couleur;
    WrkZone^.Draw;
  End;
  Dispose(D,Done);
End;

{ --- Outil : TDiaPlus --- }

Constructor TDiaPlus.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,icDiaphragme,cmDiaphInfo,#0,#32,'Ajout d''un diaphragme','Alt-D');
  OutilAspect:=MouseDiaph;
  HelpCtx:='Diaphragme (Outil)';
  DiaphDiam:=50;
  DiaphCoul:=11;
End;

Procedure TDiaPlus.WrkZoneClic(P : TPoint);
Var X : Real;
Begin
  X:=RX(P.X);
  WrkZone^.Insert(New(PDiaph,Init(X,DiaphDiam,DiaphCoul)));
  WrkZone^.Draw;
  Modif:=TRUE;
  SetCommand(cmModif);
End;

{ --- Info : TDiaInfo --- }

Constructor TDiaInfo.Init(Creer : Boolean ; T : String);
Var E : PEdit;
Begin
  inherited Init(50,50,287,125,T);
  Ident:='DIA:DIAPH';
  HelpCtx:='Diaphragme (Dialogue)';
  If Creer Then
    Insert(New(PButton,Init(94 ,98,cmNew,   'Crer',  0,#0,#0)));
  Insert(New(PButton,Init(152,98,cmOK,    'OK',     btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(200,98,cmAnnule,'Annuler',btMotifEsc  ,#27,#0)));
  Insert(New(PIcone2,Init(13,26,12)));
  E:=New(PReEdit,Init(150,26,15));
  Insert(E);
  Insert(New(PReEdit,Init(150,50,15)));
  Insert(New(PCoPalet,Init(9,71)));
  E^.Select;
End;

Procedure TDiaInfo.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+62,P.Y+30,'Diamtre :');
  OutTextXY(P.X+62,P.Y+54,'Position :');
  DrawEnd;
End;

Procedure TDiaInfo.HandleEvent(Var Event : TEvent);
Var D : TDiaRec;
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmOK     : ExitCode:=exOK;
      cmAnnule : ExitCode:=exAnnule;
      cmNew    : Begin
                   GetData(D);
                   WrkZone^.Insert(New(PDiaph,
                   Init(D.Position,Abs(D.Diametre),D.Couleur)));
                   RestitueEcran;
                   WrkZone^.Draw;
                   SauveEcran;
                   Draw;
                   Modif:=TRUE;
                   SetCommand(cmModif);
                 End;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

Procedure DiaphInfo;
Var D : PDiaInfo;
    L : TDiaRec;
Begin
  L.Diametre:=DiaphDiam;
  L.Couleur:=DiaphCoul;
  L.Position:=0;
  D:=New(PDiaInfo,Init(TRUE,'Paramtres des diaphragmes'));
  D^.SetData(L);
  Application^.Insert(D);
  If D^.Exec=exOK Then
  Begin
    D^.GetData(L);
    DiaphCoul:=L.Couleur;
    DiaphDiam:=Abs(L.Diametre);
  End;
  Dispose(D,Done);
End;

{ ==== Module : Pupille ==== }

Constructor TPupil.Init(eX,eD : Real);
Begin
  inherited Init(eX,eD,15);
  Ident:='Pupille';
End;

Procedure TPupil.Draw;
Begin
  SetLineStyle(UserBitLn,$AAAA,1);
  inherited Draw;
  SetLineStyle(SolidLn,0,1);
End;

{ ==== Module : Bougie ==== }

{ --- Element : TBougie --- }

Constructor TBougie.Init(eX,eD,eA : Real ; eTpe : Byte);
Begin
  inherited Init(eX,eD,15);
  Ident:='Bougie';
  Angle:=eA;
  Tpe:=eTpe;
End;

Procedure TBougie.Draw;
Begin
  If Tpe=1
  Then
    Begin
      If (PosX>=Zooms^.X1) AND (PosX<=Zooms^.X2)
      Then
      Begin
        Origin.X:=EX(PosX)-10-WrkZone^.Origin.X;
        Size.X:=20;
        If Diam/2>Zooms^.Y1 Then Origin.Y:=8
                            Else Origin.Y:=EY(Diam/2);
        If Origin.Y>=18 Then Origin.Y:=Origin.Y-10;
        Size.Y:=EY(0)-Origin.Y+10;
        Origin.Y:=Origin.Y-WrkZone^.Origin.Y;
        Etat:=Etat OR stVisible;
      End
      Else Etat:=Etat AND (Not (stVisible+stSelected));
    End
  Else Etat:=Etat AND (Not (stVisible+stSelected));
End;

Procedure TBougie.Write(F : PDisk);
Begin
  inherited Write(F);
  F^.Write(Angle,SizeOf(Real));
  F^.Write(Tpe,SizeOf(Byte));
End;

Procedure TBougie.Read(F : PDisk);
Begin
  inherited Read(F);
  F^.Read(Angle,SizeOf(Real));
  F^.Read(Tpe,SizeOf(Byte));
End;

Procedure TBougie.ElementClic;
Var D : PBouInfo;
    R : TBouRec;
Begin
  D:=New(PBouInfo,Init);
  R.Position:=PosX;
  R.Hauteur:=Diam;
  R.Angle:=Angle;
  R.Tpe:=Tpe;
  D^.SetData(R);
  Application^.Insert(D);
  If D^.Exec=exOK Then
  Begin
    D^.GetData(R);
    Tpe:=R.Tpe;
    Angle:=R.Angle;
    Diam:=R.Hauteur;
    PosX:=R.Position;
    WrkZone^.Draw;
  End;
  Dispose(D,Done);
End;

{ --- Info : TBouInfo ---}

Constructor TBouInfo.Init;
Var E : PReEdit;
    R : PRadio;
Begin
  inherited Init(50,50,294,148,'Paramtres de l''objet');
  Ident:='DIA:OBJET';
  Insert(New(PButton,Init(159,121,cmOK,'OK',btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(207,121,cmAnnule,'Annuler',btMotifEsc,#27,#0)));
  Insert(New(PIcone2,Init(9,51,3)));
  E:=New(PReEdit,Init(157,39,15));
  Insert(E);
  Insert(New(PReEdit,Init(157,60,15)));
  Insert(New(PReEdit,Init(157,97,15)));
  R:=New(PRadio,Init);
  R^.Insert(New(PRadItem,Init(53,23)));
  R^.Insert(New(PRadItem,Init(53,81)));
  Insert(R);
  E^.Select;
End;

Procedure TBouInfo.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+75,P.Y+26,' distance finie :');
    OutTextXY(P.X+69,P.Y+43,'Position :');
    OutTextXY(P.X+69,P.Y+64,'Hauteur  :');
  OutTextXY(P.X+75,P.Y+84,' l''infini :');
    OutTextXY(P.X+69,P.Y+101,'Angle  :');
  DrawEnd;
End;

Procedure TBouInfo.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmOK     : ExitCode:=exOK;
      cmAnnule : ExitCode:=exAnnule;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

BEGIN
END.