{**********************************************************}
{                                                          }
{                   Projet SoftOptique                     }
{                   Aide  contextuelle                     }
{                                                          }
{   Debut du projet : 10.04.93                   cm0=500   }
{   Mise A Jour     : 01.06.93                             }
{                                                          }
{**********************************************************}
UNIT Help;

INTERFACE

Uses Drivers,ObjetAbs,Objet;

Const
     cmHelp  = 500;
     cmIndex = cmHelp+00;
     cmUp    = cmHelp+01;
     cmDown  = cmHelp+02;
     cmLift  = cmHelp+03;
     cmSuiv  = cmHelp+04;
     cmPrec  = cmHelp+05;

Type PEntree  = ^TEntree;
     PPage    = ^TPage;
     TEntree  = Record
                  Suivant : PEntree;
                  Texte   : String;
                  Tpe     : Word;
                  Origin  : TPoint;
                End;
     TPage    = Record
                  Liste   : PEntree;
                  Suivant : PPage;
                  Titre   : String;
                End;
     PLift    = ^TLift;
     TLift    = Object(TGroup)
                  Pos : Word;
                  Max : Word;
                  Pas : Word;
                  Vis : Word;
                  Constructor Init(X,Y,H,eMax,ePas,eVis : Word);
                  Procedure   Draw;                                  Virtual;
                  Procedure   DrawLift;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     PLiftBut = ^TLiftBut;
     TLiftBut = Object(TAbsBut)
                  Tpe : Word;     { 1=Up, 2=Down }
                  Constructor Init(X,Y,eTpe : Word);
                  Procedure   Draw;                                  Virtual;
                End;
     TextElt  = Record
                  Ch : Char;
                  Co : Byte;
                End;
     TextLgn  = Array[0..49] Of TextElt;
     PHelpDia = ^THelpDia;
     THelpDia = Object(TDialog)
                  Page : PPage;
                  Lift : PLift;
                  Text : Array[0..50] Of TextLgn;
                  NbL  : Integer;
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   PreparePage;
                  Procedure   DrawPage;
                End;

Var InHelp : Boolean;

Procedure HelpInit;
Procedure HelpDone;

IMPLEMENTATION

Uses Graph,Disk,Crt;

Const
     teIndex  = $0001;

Var FHelp : PPage;

{ ==== Module : Lecture du fichier d'aide ==== }

Procedure HelpInit;
Var F : TDisk;
    P : PPage;
  Procedure AddEntree(E : PEntree);
  Var E1 : PEntree;
  Begin
    If P^.Liste=NIL
    Then P^.Liste:=E
    Else
      Begin
        E1:=P^.Liste;
        While (E1^.Suivant<>NIL) do
          E1:=E1^.Suivant;
        E1^.Suivant:=E;
      End;
 End;
  Procedure LitPage;
  Var C : Char;
      E : PEntree;
  Begin
    P:=NIL;
    F.Read(C,1);
    If C<>'#' Then Exit;
    P:=New(PPage);
    P^.Titre:='';
    P^.Liste:=NIL;
    P^.Suivant:=NIL;
    F.Read(C,1);
    While Not (C IN [#13,#10]) do
    Begin
      P^.Titre:=P^.Titre+C;
      F.Read(C,1);
    End;
    While C IN [#13,#10] do F.Read(C,1);
    While Not (C IN ['#','*']) do
    Begin   { Lit un Element }
      E:=New(PEntree);
      E^.Texte:='';
      E^.Tpe:=0;
      E^.Suivant:=NIL;
      If C='$'
      Then
        Begin
          E^.Tpe:=E^.Tpe OR teIndex;
          F.Read(C,1);
          While C<>'$' do
          Begin
            E^.Texte:=E^.Texte+C;
            F.Read(C,1);
          End;
          F.Read(C,1);     { Se place au dbut du suivant }
        End
      Else
        Begin
          While Not (C IN [#10,#13,'$']) do
          Begin
            E^.Texte:=E^.Texte+C;
            F.Read(C,1);
          End;
          While C IN [#10,#13] do
          Begin
            E^.Texte:=E^.Texte+C;
            F.Read(C,1);
          End;
        End;
      AddEntree(E);
    End;
    F.Seek(-1,stCourant);  { Se positionne sur le '#' }
  End;
  Procedure BuildIndex;
  Var P2 : PPage;
      E  : PEntree;
  Begin
    P:=New(PPage);
    P^.Titre:='Index';
    P^.Liste:=NIL;
    P^.Suivant:=NIL;
    P2:=FHelp;
    While (P2<>NIL) do
    Begin
      { Insre l'entre d'index }
      E:=New(PEntree);
      E^.Texte:=P2^.Titre;
      E^.Tpe:=teIndex;
      E^.Suivant:=NIL;
      AddEntree(E);
      { Insre le saut de ligne }
      E:=New(PEntree);
      E^.Texte:=#13#10;
      E^.Tpe:=0;
      E^.Suivant:=NIL;
      AddEntree(E);
      P2:=P2^.Suivant;
    End;
  End;
Begin
  F.Init(AppPath+'Optique.HLP',stOpen);
  Repeat
    LitPage;
    If P<>NIL Then
    Begin
      P^.Suivant:=FHelp;
      FHelp:=P;
    End;
  Until P=NIL;
  F.Done;
  BuildIndex;
  P^.Suivant:=FHelp;
  FHelp:=P;
  InHelp:=FALSE;
End;

Procedure HelpDone;
Var P,P1 : PPage;
    E,E1 : PEntree;
Begin
  P:=FHelp;
  While P<>NIL do
  Begin
    P1:=P^.Suivant;
    E:=P^.Liste;
    While E<>NIL do
    Begin
      E1:=E^.Suivant;
      Dispose(E);
      E:=E1;
    End;
    Dispose(P);
    P:=P1;
  End;
End;

Procedure HelpSearch(Clef : String ; Var Found : PPage);
Var P : PPage;
Begin
  P:=FHelp;
  Found:=NIL;
  Clef:=UpStr(Clef);
  While (P<>NIL) do
  Begin
    If UpStr(P^.Titre)=Clef Then Begin Found:=P; Exit; End;
    P:=P^.Suivant;
  End;
End;

{ ==== Module : TLift ==== }

Constructor TLiftBut.Init(X,Y,eTpe : Word);
Begin
  If eTpe=1 Then inherited Init(X,Y,14,15,cmUp,eTpe,btAuto,#0,#72)
            Else inherited Init(X,Y,14,15,cmDown,eTpe,btAuto,#0,#80);
  Tpe:=eTpe;
End;

Procedure TLiftBut.Draw;
Var P : TPoint;
    M : Byte;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  If Tpe=1 Then M:=7 Else M:=8;
  PutImage(P.X+3,P.Y+3,Motifs[M]^,NormalPut);
  DrawEnd;
End;

Constructor TLift.Init(X,Y,H,eMax,ePas,eVis : Word);
Begin
  inherited Init(X,Y,16,H,7);
  Insert(New(PLiftBut,Init(1,H-32,1)));
  Insert(New(PLiftBut,Init(1,H-16,2)));
  Max:=eMax;
  Pas:=ePas;
  Vis:=eVis;
  Pos:=0;
End;

Procedure TLift.DrawLift;
Var P : TPoint;
    Y : Integer;
    H : Integer;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  SetFillStyle(SolidFill,8);
  Bar(P.X+1,P.Y+1,P.X+14,P.Y+Size.Y-34);
  H:=Trunc((Size.Y-34)/(Max+1)*Vis);
  If H<30 Then H:=30;
  Y:=Trunc((Size.Y-34-H)*Pos/(Max-Vis+1));
  OutLine(P.X+1,P.Y+1+Y,14,H,15,7,8,0);
  SetFillStyle(SolidFill,7);
  Bar(P.X+3,P.Y+3+Y,P.X+12,P.Y+Y+H-2);
  PutImage(P.X+5,P.Y+Y+1+((H-6) div 2),Motifs[16]^,NormalPut);
  DrawEnd;
End;

Procedure TLift.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  If Max>Vis
  Then
    Begin
      inherited Draw;
      DrawLift;
    End
  Else
    Begin
      MakeGlobal(Origin,P);
      SetFillStyle(SolidFill,8);
      Bar(P.X+1,P.Y+1,P.X+14,P.Y+Size.Y-2);
    End;
  DrawEnd;
End;

Procedure TLift.HandleEvent(Var Event : TEvent);
Begin
  If Max<=Vis Then Exit;
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command of
      cmUp   : If Pos>0 Then
               Begin
                 If Pos>Pas Then Dec(Pos,Pas) Else Pos:=0;
                 DrawLift;
                 SetCommand(cmLift);
               End;
      cmDown : If Pos+Vis-1<Max Then
               Begin
                 Inc(Pos,Pas);
                 If Pos+Vis-1>Max Then Pos:=Max-Vis+1;
                 DrawLift;
                 SetCommand(cmLift);
               End;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

{ ==== Module : Consultation du fichier d'aide ==== }

Constructor THelpDia.Init;
Begin
  inherited Init(50,50,429,204,'Aide');
  Insert(New(PButton,Init(298,180,cmIndex,'Index',0,'I',#0)));
  Insert(New(PButton,Init(353,180,cmOK,'Fermer',btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(227,180,cmSuiv,'Suivant',0,'S',#0)));
  Insert(New(PButton,Init(140,180,cmPrec,'Prcdent',0,'P',#0)));
  Lift:=New(PLift,Init(412,18,155,10,8,15));
  Insert(Lift);
  HelpSearch(GlobalHelp,Page);
  PreparePage;
  InHelp:=TRUE;
End;

Procedure THelpDia.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);  Line(P.X+411,P.Y+18,P.X+411,P.Y+172);
  SetColor(8);  Line(P.X+1,P.Y+173,P.X+427,P.Y+173);
  SetColor(15); Line(P.X+1,P.Y+174,P.X+427,P.Y+174);
  DrawPage;
  DrawEnd;
End;

Procedure THelpDia.HandleEvent(Var Event : TEvent);
Var P   : PPage;
    Pos : TPoint;
    Y,X : Integer;
    E,F : PEntree;
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evCommand    : Begin
                     Case Event.Command Of
                       cmOK    : Begin ExitCode:=exOK; InHelp:=FALSE; End;
                       cmIndex : If Page^.Titre<>'Index' Then
                                 Begin
                                   HelpSearch('Index',Page);
                                   PreparePage;
                                   Lift^.Draw;
                                   DrawPage;
                                 End;
                       cmLift  : DrawPage;
                       cmSuiv  : If Page^.Suivant<>NIL Then
                                 Begin
                                   Page:=Page^.Suivant;
                                   PreparePage;
                                   Lift^.Draw;
                                   DrawPage;
                                 End;
                       cmPrec  : If Page<>FHelp Then
                                 Begin
                                   P:=fHelp;
                                   While (P^.Suivant<>Page) do
                                     P:=P^.Suivant;
                                   Page:=P;
                                   PreparePage;
                                   Lift^.Draw;
                                   DrawPage;
                                 End;
                     Else
                       Exit;
                     End;
                     Event.What:=evNothing;
                   End;
    evMouseLDown : Begin
                     MakeGlobal(Origin,Pos);
                     If (Event.Where.X>Pos.X) AND (Event.Where.X<Pos.X+410) AND
                        (Event.Where.Y>Pos.Y+17) AND (Event.Where.Y<Pos.Y+172) Then
                     Begin
                       Y:=((Event.Where.Y-(Pos.Y+21)) div 10)+Lift^.Pos;
                       X:=(Event.Where.X-(Pos.X+6)) div 8;
                       If Text[Y][X].Co=14 Then
                       Begin
                         While (X>=0) AND (Text[Y][X].Co=14) do Dec(X);
                         Inc(X);
                         E:=Page^.Liste;
                         F:=NIL;
                         While (E<>NIL) do
                         Begin
                           If (E^.Origin.X=X) AND (E^.Origin.Y=Y) Then F:=E;
                           E:=E^.Suivant;
                         End;
                         If F<>NIL Then
                         Begin
                           HelpSearch(F^.Texte,P);
{** Pour test **}          If P=NIL Then Begin Write(#7); Exit; End;
                           Page:=P;
                           PreparePage;
                           Lift^.Draw;
                           DrawPage;
                         End;
                       End;
                       Event.What:=evNothing;
                     End;
                   End;
    evKeyDown    : If (Event.C1=#27) AND (Event.C2=#0) Then
                   Begin
                     SetCommand(cmOK);
                     Event.What:=evNothing;
                   End;
  End;
End;

Procedure THelpDia.PreparePage;
Var E   : PEntree;
    X   : Integer;
    I,C : Byte;
Begin
  FillChar(Text[0],SizeOf(TextLgn),0);
  FillChar(Text[1],SizeOf(TextLgn),0);
  FillChar(Text[2],SizeOf(TextLgn),0);
  X:=(50-Length(Page^.Titre)) div 2;
  For I:=1 to Length(Page^.Titre) do
  Begin
    Text[1][X+I].Ch:=Page^.Titre[I];
    Text[1][X+I].Co:=15;
  End;
  X:=0;NbL:=3;FillChar(Text[NbL],SizeOf(TextLgn),0);
  E:=Page^.Liste;
  While (E<>NIL) do
  Begin
    E^.Origin.X:=X;
    E^.Origin.Y:=NbL;
    If (E^.Tpe AND teIndex)<>0 Then C:=14 Else C:=0;
    I:=1;
    While (I<=Length(E^.Texte)) do
      If E^.Texte[I] IN [#13,#10]
      Then
        Begin
          X:=0; Inc(NbL);
          FillChar(Text[NbL],SizeOf(TextLgn),0);
          Inc(I,2);
        End
      Else
        Begin
          Text[NbL][X].Ch:=E^.Texte[I];
          Text[NbL][X].Co:=C;
          Inc(X);
          If X=51 Then
          Begin
            While (Not (E^.Texte[I] IN [' ','-'])) AND (I>0) Do
            Begin
              Dec(X);
              Dec(I);
              Text[NbL][X].Ch:=#0;
            End;
            X:=0; Inc(NbL);
            While (E^.Texte[I] IN [' ','-']) do Inc(I);
            FillChar(Text[NbL],SizeOf(TextLgn),0);
          End Else Inc(I);
        End;
    E:=E^.Suivant;
  End;
  Lift^.Max:=NbL;
  Lift^.Pos:=0;
End;

Procedure THelpDia.DrawPage;
Var X,Y,I : Integer;
    P     : TPoint;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  Y:=0;
  I:=Lift^.Pos;
  SetFillStyle(SolidFill,7);
  While (I<=NbL) AND (Y<15) do
  Begin
    Bar(P.X+6,P.Y+Y*10+22,P.X+6+399,P.Y+Y*10+22+7);
    For X:=0 to 49 do
      If Text[I][X].Ch<>#0 Then
      Begin
        SetColor(Text[I][X].Co);
        OutTextXY(P.X+X*8+6,P.Y+Y*10+22,Text[I][X].Ch);
      End;
    Inc(I);
    Inc(Y);
  End;
  While (Y<15) do
  Begin
    Bar(P.X+6,P.Y+Y*10+22,P.X+6+399,P.Y+Y*10+22+7);
    Inc(Y);
  End;
  DrawEnd;
End;

BEGIN
END.