Program Icones;

Uses Graph,Disk,Drivers,IFF;

Const
    Coord  : Array[1..NbIco,1..2] Of Integer =
            ((218,32),(218,53),(218,74),(218,95),
             (239,32),(239,53),(239,74),(260,32),
             (281,32),(260,74),(239,95),(260,95),
             (260,53));
    Coord2 : Array[1..NbIco2,1..2] Of Integer =
             ((352,65),(385,32),(352,32),(319,32),
              (319,65),(385,65),(418,65),(418,32),
              (451,32),(451,65),(484,32),(484,65));
    Mot    : Array[1..NbMot,1..4] Of Integer =
            ((11,8,148,177),(9,8,162,177),(7,8,174,177),(200,35,249,292),
             (8,7,184,177),(8,7,195,177),(7,8,206,177),(7,8,216,177),
             (7,7,226,177),(7,7,236,177),(23,9,303,166),(28,12,337,165),
             (20,6,303,182),(14,14,246,177),(14,14,263,177),(6,6,280,177));
    Mouses : Array[1..NbMouses,1..4] Of Integer =
            ((1,1,58,83), (1,1,75,83), (3,6,92,83),
             (5,6,58,100),(5,6,75,100),(5,5,92,100),
             (5,6,58,117),(5,6,75,117),(6,6,92,117),
             (3,7,109,83),(1,7,109,100),(3,7,109,117));

Var Carte,Mode  : Integer;
    X,Y,L,M     : Word;
    S           : TDisk;
    I,J,K,P     : Byte;
    Image       : Pointer;
    Co          : TColor;
    Mouse       : TMouseAspect;
    St          : String;

BEGIN
  Carte:=Detect;
  InitGraph(Carte,Mode,'C:\langages\tp\bgi');
  SetFillStyle(SolidFill,15);
  Decompile(Co,'Icones.Lbm');
  S.Init('Icones.Dat',stCreate);
  { Transfert de l'en-tte }
  St:='Fichier systme SoftOptique V1.0'+#13#10#26;
  S.Write(St[1],35);
  { Transfert la palette de couleurs }
  S.Write(Co,48);
  { Transfert les icones 20x20 }
  L:=ImageSize(1,1,20,20);
  GetMem(Image,L);
  For I:=1 to NbIco do
  Begin
    X:=Coord[I,1];
    Y:=Coord[I,2];
    GetImage(X,Y,X+19,Y+19,Image^);
    Bar(X,Y,X+19,Y+19);
    S.Write(Image^,L);
  End;
  FreeMem(Image,L);
  { Transfert les icones 32x32 }
  L:=ImageSize(1,1,32,32);
  GetMem(Image,L);
  For I:=1 to NbIco2 do
  Begin
    X:=Coord2[I,1];
    Y:=Coord2[I,2];
    GetImage(X,Y,X+31,Y+31,Image^);
    Bar(X,Y,X+31,Y+31);
    S.Write(Image^,L);
  End;
  FreeMem(Image,L);
  { Transfert les icones de taille quelconque }
  For I:=1 to NbMot do
  Begin
    S.Write(Mot[I,1],SizeOf(Integer));
    S.Write(Mot[I,2],SizeOf(Integer));
    L:=ImageSize(1,1,Mot[I,1],Mot[I,2]);
    GetMem(Image,L);
    X:=Mot[I,3];
    Y:=Mot[I,4];
    GetImage(X,Y,X+Mot[I,1]-1,Y+Mot[I,2]-1,Image^);
    Bar(X,Y,X+Mot[I,1]-1,Y+Mot[I,2]-1);
    S.Write(Image^,L);
    FreeMem(Image,L);
  End;
  { Transfert les chiffres digitaux }
  L:=ImageSize(1,1,7,12);
  GetMem(Image,L);
  For I:=0 to NbChiffres do
  Begin
    GetImage(87+I*8,221,93+I*8,232,Image^);
    Bar(87+I*8,221,93+I*8,232);
    S.Write(Image^,L);
  End;
  FreeMem(Image,L);
  { Transfert les dessins de souris }
  For I:=1 to NbMouses do
  Begin
    Mouse.DX:=Mouses[I,1];
    Mouse.DY:=Mouses[I,2];
    X:=Mouses[I,3];
    Y:=Mouses[I,4];
    For J:=1 to 16 do
    Begin
      M:=$8000;
      Mouse.cAND[J]:=$FFFF;
      Mouse.cOR[J] :=$0000;
      For K:=1 to 16 do
      Begin
        P:=GetPixel(X+K-1,Y+J-1);
        PutPixel(X+K-1,Y+J-1,12);
        If P in [0,15] Then Mouse.cAND[J]:=Mouse.cAND[J] AND (Not M);
        If P=15 Then Mouse.cOR[J]:=Mouse.cOR[J] OR M;
        M:=M SHR 1;
      End;
    End;
    S.Write(Mouse,SizeOf(TMouseAspect));
  End;
  Readln;
  S.Done;
  CloseGraph;
  Writeln('Fichier Icones Ecrit');
  Writeln;
  Writeln;
END.