{**********************************************************}
{                                                          }
{                   Projet SoftOptique                     }
{                   Librairie d'objets                     }
{    TDialog : fentre de dialogue                         }
{    TAbsBut : Bouton abstrait, pour drivation            }
{    TButton : Bouton normal, avec texte                   }
{    TIcone  : Icone abstrait, pour drivation             }
{    TOutil  : Icone-outil                                 }
{    TAction : Icone-action                                }
{    TCoche  : Case  cocher                               }
{    TEdit   : Ligne d'dition normale                     }
{    TReEdit : Ligne d'dition de rels                    }
{    TFiEdit : Ligne d'dition de noms de fichier          }
{    TIcone2 : Icone 32x32, passif                         }
{    TCoPalet: Palette de 16 couleurs                      }
{    TMenu   : Pop-Up menu                                 }
{    TMenuId : Element d'un Pop-Up Menu                    }
{    TRadio  : Groupe de boutons radio en exclusion        }
{    TRadItem: Bouton Radio                                }
{    THotKey : Raccourcis clavier sans dessin              }
{                                                          }
{   Debut du projet : 10.04.93                             }
{   Mise A Jour     : 02.06.93                             }
{                                                          }
{**********************************************************}

UNIT Objet;

INTERFACE

Uses Drivers,ObjetAbs;

Const
  { Constantes des motifs pour boutons }
     btNoMotif    = 000;
     btMotifEnter = 001;
     btMotifEsc   = 002;

  { Constantes de l'Options de TAbsBut }
     btAuto       = $0001;
     btUpCase     = $0002;
     btWait       = $0004;

Type
     PDialog  = ^TDialog;
     PAbsBut  = ^TAbsBut;
     PButton  = ^TButton;
     PIcone   = ^TIcone;
     POutil   = ^TOutil;
     PAction  = ^TAction;
     PCoche   = ^TCoche;
     PEdit    = ^TEdit;
     PReEdit  = ^TReEdit;
     PFiEdit  = ^TFiEdit;
     PIcone2  = ^TIcone2;
     PCoPalet = ^TCoPalet;
     PMenu    = ^TMenu;
     PMenuId  = ^TMenuId;
     PRadio   = ^TRadio;
     PRadItem = ^TRadItem;
     PHotKey  = ^THotKey;
     TDialog  = Object(TGroup)
                  Titre : String;
                  Sauve : Pointer;
                  LSauve: Integer;
                  Constructor Init(X,Y,L,H : Integer ; eTitre : String);
                  Procedure   Draw;                                  Virtual;
                  Procedure   SauveEcran;                            Virtual;
                  Procedure   RestitueEcran;                         Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TAbsBut  = Object(TObjet)
                  Commande: Integer;
                  Info    : Integer;
                  Options : Word;
                  C1,C2   : Char;
                  Constructor Init(X,Y,L,H,eComm,eInfo,eOptions : Integer ;
                                   eC1,eC2 : Char);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TButton  = Object(TAbsBut)
                  Titre   : String;
                  NbMotif : Byte;
                  Constructor Init(X,Y,eComm : Integer ; eTitre : String ;
                                   eNbMotif : Byte ; eC1,eC2 : Char);
                  Procedure   Draw;                                  Virtual;
                End;
     TIcone   = Object(TObjet)
                  Dessin   : Byte;
                  CommandL : Word;
                  CommandR : Word;
                  C1,C2    : Char;
                  Descrip  : String;
                  HotKey   : String;
                  Constructor Init(X,Y : Integer ; eDessin : Byte ;
                                   eComL,eComR : Word ; eC1,eC2 : Char ;
                                   eDes,eHot : String);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   ActionL(Var Event : TEvent);           Virtual;
                  Procedure   ActionR(Var Event : TEvent);
                End;
     TOutil   = Object(TIcone)
                  OutilAspect : PMouseAspect;
                  Constructor Init(X,Y : Integer ; eDessin : Byte ;
                                   eCom : Word ; eC1,eC2 : Char ;
                                   eDes,eHot : String);
                  Procedure   ActionL(Var Event : TEvent);           Virtual;
                  Procedure   WrkZoneClic(P : TPoint);               Virtual;
                  Procedure   ElementClic(E : PObjet ; Var Event : TEvent);
                                                                     Virtual;
                End;
     TAction  = Object(TIcone)
                  Procedure   ActionL(Var Event : TEvent);           Virtual;
                End;
     TCoche   = Object(TObjet)
                  Valeur : Boolean;
                  Constructor Init(X,Y : Integer);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   SetData(Var Rec);                      Virtual;
                  Procedure   GetData(Var Rec);                      Virtual;
                  Function    DataSize : Integer;                    Virtual;
                End;
     TEdit    = Object(TObjet)
                  Lt     : Byte;
                  Texte  : String;
                  Ins    : Boolean;
                  CPos   : Byte;
                  Constructor Init(X,Y : Integer ; eLt : Byte);
                  Procedure   Draw;                                  Virtual;
                  Procedure   SetData(Var Rec);                      Virtual;
                  Procedure   GetData(Var Rec);                      Virtual;
                  Function    DataSize : Integer;                    Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Function    Valid(Var C : Char) : Boolean;         Virtual;
                  Procedure   DrawTxt(Deb : Byte);
                  Procedure   UnSelect;
                  Procedure   Select;
                  Procedure   SelectSuiv;
                  Procedure   SelectPrec;
                  Procedure   DrawCursor;
                End;
     TFiEdit  = Object(TEdit)
                  Function    Valid(Var C : Char) : Boolean;         Virtual;
                End;
     TReEdit  = Object(TEdit)
                  Procedure   SetData(Var Rec);                      Virtual;
                  Procedure   GetData(Var Rec);                      Virtual;
                  Function    DataSize : Integer;                    Virtual;
                  Function    Valid(Var C : Char) : Boolean;         Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TIcone2  = Object(TObjet)
                  No : Byte;
                  Constructor Init(X,Y : Integer ; eNo : Byte);
                  Procedure   Draw;                                  Virtual;
                End;
     TCoPalet = Object(TObjet)
                  Co : Byte;
                  Constructor Init(X,Y : Integer);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Function    DataSize : Integer;                    Virtual;
                  Procedure   GetData(Var Rec);                      Virtual;
                  Procedure   SetData(Var Rec);                      Virtual;
                  Procedure   DrawMark;
                End;
     TMenu    = Object(TDialog)
                  Constructor Init(X,Y : Integer ; eTit : String);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   Prepare;
                End;
     TMenuId  = Object(TAbsBut)
                  Texte  : String[20];
                  Hot    : String[10];
                  PHot   : Integer;
                  Constructor Init(eTex,eHot : String ; eC1,eC2 : Char ; eComm : Integer);
                  Procedure   Draw;                                  Virtual;
                End;
     TRadio   = Object(TGroup)
                  Constructor Init;
                  Function    DataSize : Integer;                    Virtual;
                  Procedure   SetData(Var Rec);                      Virtual;
                  Procedure   GetData(Var Rec);                      Virtual;
                End;
     TRadItem = Object(TObjet)
                  Constructor Init(X,Y : Integer);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     THotKey  = Object(TObjet)
                  C1,C2 : Char;
                  Comm  : Word;
                  Constructor Init(eC1,eC2 : Char ; eComm : Word);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;

Var Outil : POutil;      { Outil courant                          }
    Modif : Boolean;     { Flag de modification                   }
    NomFichier : String; { Nom du fichier courant                 }
    Transfert  : Real;   { Tranfert entre calculatrice et TReEdit }

IMPLEMENTATION

Uses Crt,Dos,Graph;

{ ==== Module : TDialog ==== }

Constructor TDialog.Init(X,Y,L,H : Integer ; eTitre : String);
Begin
  inherited Init(X,Y,L,H,7);
  Ident:='DIALOG';
  HelpCtx:='Boite de dialogue';
  Titre:=eTitre;
End;

Procedure TDialog.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  Outline(P.X,P.Y,Size.X,18,0,15,8,0);
  SetColor(0);
  Rectangle(P.X,P.Y,P.X+Size.X-1,P.Y+Size.Y-1);
  OutTextXY(P.X+((Size.X-TextWidth(Titre)) div 2),P.Y+5,Titre);
  DrawEnd;
End;

Procedure TDialog.SauveEcran;
Var P : TPoint;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  LSauve:=ImageSize(P.X,P.Y,P.X+Size.X-1,P.Y+Size.Y-1);
  GetMem(Sauve,LSauve);
  GetImage(P.X,P.Y,P.X+Size.X-1,P.Y+Size.Y-1,Sauve^);
  DrawEnd;
End;

Procedure TDialog.RestitueEcran;
Var P : TPoint;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  PutImage(P.X,P.Y,Sauve^,NormalPut);
  FreeMem(Sauve,LSauve);
  DrawEnd;
End;

{
Procedure TDialog.SauveEcran;
Var AdS,AdD,L,H : Word;
    P           : TPoint;
Label Bcl;
Begin
  MouseHide;
  MakeGlobal(Origin,P);
  AdS:=(P.X div 8)+P.Y*80;
  L:=(Size.X div 8)+2;
  H:=Size.Y;
  AdD:=65536-L*H;
  asm
      PUSH    DS              Sauve les registres de segments qui sont
      PUSH    ES              Utiliss par le pascal
      MOV     DX,03CEh       Adresse du controleur vido EGA/VGA
      MOV     AX,0105h        Mode Read 0, Mode Write 1
      OUT     DX,AX
      MOV     SI,AdS          Adresse source
      MOV     DI,AdD          Adresse destination : page inutilise
      MOV     DX,L            Largeur en octets  sauver
      MOV     BX,H            Nombre de lignes  sauver
      MOV     AX,0A000h       Le segment de l'cran
      MOV     DS,AX           est  la fois source et destination
      MOV     ES,AX
      CLD                     On va dans le bon sens
Bcl:    MOV     CX,DX         Nombre d'octets  transfrer
    REP MOVSB                 Effectue le tranfert
        SUB     SI,DX         Passe  la ligne suivante
        ADD     SI,80
        DEC     BX            Et termine la sauvegarde
        JNZ     Bcl
      POP     ES              Restaure les registres segments utiliss
      POP     DS
  end;
  MouseShow;
End;

Procedure TDialog.RestitueEcran;
Var AdS,AdD,L,H : Word;
    P           : TPoint;
Label Bcl;
Begin
  MouseHide;
  MakeGlobal(Origin,P);
  AdD:=(P.X div 8)+P.Y*80;
  L:=(Size.X div 8)+2;
  H:=Size.Y;
  AdS:=65536-L*H;
  asm
      PUSH    DS              Sauve les registres de segments qui sont
      PUSH    ES              Utiliss par le pascal
      MOV     DX,03CEh        Adresse du controleur vido EGA/VGA
      MOV     AX,0105h        Mode Read 0, Mode Write 1
      OUT     DX,AX
      MOV     SI,AdS          Adresse source : page inutilise
      MOV     DI,AdD          Adresse destination
      MOV     DX,L            Largeur en octets  sauver
      MOV     BX,H            Nombre de lignes  sauver
      MOV     AX,0A000h       Le segment de l'cran
      MOV     DS,AX           est  la fois source et destination
      MOV     ES,AX
      CLD                     On va dans le bon sens !
Bcl:    MOV     CX,DX         Nombre d'octets  transfrer
    REP MOVSB                 Effectue le tranfert
        SUB     DI,DX         Passe  la ligne suivante
        ADD     DI,80
        DEC     BX            Et termine la sauvegarde
        JNZ     Bcl
      POP     ES              Restaure les registres segments utiliss
      POP     DS
  end;
  MouseShow;
End;
}
Procedure TDialog.HandleEvent(Var Event : TEvent);
Var P           : TPoint;
    Xs,Ys,dX,dY : Integer;
    ZL,T,S,MS   : Word;
Begin
  inherited HandleEvent(Event);
  If Event.What=evMouseLDown Then
  Begin
    MakeGlobal(Origin,P);
    If (Event.Where.X>=P.X) AND (Event.Where.X<=P.X+Size.X-1) AND
       (Event.Where.Y>=P.Y) AND (Event.Where.Y<=P.Y+17) Then
    Begin
      Xs:=MouseX; Ys:=MouseY;
      dX:=0;      dY:=0;
      MouseHide;
      SetWriteMode(XORPut);
      SetColor(15);
      ZL:=1; SetLineStyle(UserBitLn,ZoneDefLn[ZL],1);
      GetTime(T,T,T,S);
      MS:=S;
      Rectangle(P.X,P.Y,P.X+Size.X-1,P.Y+Size.Y-1);
      Repeat
        GetMouseEvent(Event);
        StLine^.HandleEvent(Event);
        SetColor(15);
        If Event.What=evMouseMove Then
        Begin
          Rectangle(P.X+dX,P.Y+dY,P.X+Size.X-1+dX,P.Y+Size.Y-1+dY);
          dX:=Event.Where.X-Xs;
          dY:=Event.Where.Y-Ys;
          If (P.X+dX<0) Then dX:=-P.X;
          If (P.X+dY<0) Then dY:=-P.Y;
          If (P.X+Size.X-1+dX>GetMaxX) Then dX:=GetMaxX-P.X-Size.X+1;
          If (P.Y+Size.Y-1+dY>GetMaxY) Then dY:=GetMaxY-P.Y-Size.Y+1;
          Rectangle(P.X+dX,P.Y+dY,P.X+Size.X-1+dX,P.Y+Size.Y-1+dY);
        End;
        GetTime(T,T,T,S);
        If (S-MS>1) Then
        Begin
          MS:=S;
          Inc(ZL);
          If ZL=5 Then ZL:=1;
          Rectangle(P.X+dX,P.Y+dY,P.X+Size.X-1+dX,P.Y+Size.Y-1+dY);
          SetLineStyle(UserBitLn,ZoneDefLn[ZL],1);
          Rectangle(P.X+dX,P.Y+dY,P.X+Size.X-1+dX,P.Y+Size.Y-1+dY);
        End;
      Until Event.What=evMouseLUp;
      Rectangle(P.X+dX,P.Y+dY,P.X+Size.X-1+dX,P.Y+Size.Y-1+dY);
      SetLineStyle(SolidLn,0,1);
      SetWriteMode(NormalPut);
      MouseShow;
      If (Abs(dX)>3) OR (Abs(dY)>3) Then
      Begin
        RestitueEcran;
        Inc(Origin.X,dX);
        Inc(Origin.Y,dY);
        SauveEcran;
        Draw;
      End;
      Event.What:=evNothing;
    End;
  End;
End;

{ ==== Module : TAbsBut === }

Constructor TAbsBut.Init(X,Y,L,H,eComm,eInfo,eOptions : Integer ;
                         eC1,eC2 : Char);
Begin
  inherited Init(X,Y,L,H,7);
  Ident:='ABSBUTTON';
  HelpCtx:='Bouton';
  Commande:=eComm;
  Info:=eInfo;
  Options:=eOptions;
  C1:=eC1;C2:=eC2;
End;

Procedure TAbsBut.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  if (Etat AND stSelected)<>0
    Then Outline(P.X,P.Y,Size.X,Size.Y,8,0,7,15)
    Else Outline(P.X,P.Y,Size.X,Size.Y,15,7,8,0);
  DrawEnd;
End;

Procedure TAbsBut.HandleEvent(Var Event : TEvent);
Var P : TPoint;
  Procedure Select;
  Begin
    DrawBegin;
    Etat:=Etat OR stSelected;
    MakeGlobal(Origin,P);
    Outline(P.X,P.Y,Size.X,Size.Y,8,0,7,15);
    DrawEnd;
  End;
  Procedure UnSelect;
  Begin
    DrawBegin;
    Etat:=Etat AND (Not stSelected);
    MakeGlobal(Origin,P);
    Outline(P.X,P.Y,Size.X,Size.Y,15,7,8,0);
    DrawEnd;
  End;
  Function UpCase1(C : Char) : Char;
  Begin
    If (Options AND btUpCase)<>0 Then UpCase1:=UpCase(C)
                                 Else UpCase1:=C;
  End;
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evMouseLDown : If MouseInObjet Then
                     If (Commande AND cmInterdite)=0 Then
                     Begin
                       Select;
                       Event.What:=evNothing;
                     End;
    evAuto       : If (Options AND btAuto)<>0 Then
                     If (Etat AND stSelected)<>0 Then
                       If MouseInObjet Then
                       Begin
                         Event.What:=evCommand;
                         Event.Command:=Commande;
                         Event.InfoInt:=Info;
                         SetEvent(Event);
                         Event.What:=evNothing;
                       End;
    evMouseLUp   : If (Etat AND stSelected)<>0 Then
                   Begin
                     If MouseInObjet Then
                     Begin
                       Event.What:=evCommand;
                       Event.Command:=Commande;
                       Event.InfoInt:=Info;
                       SetEvent(Event);
                     End;
                     UnSelect;
                     Event.What:=evNothing;
                   End;
    evKeyDown    : If (UpCase1(Event.C1)=C1) AND (Event.C2=C2) Then
                     If (Commande AND cmInterdite)=0 Then
                     Begin
                       Select;
                       Event.What:=evCommand;
                       Event.Command:=Commande;
                       Event.InfoInt:=Info;
                       SetEvent(Event);
                       If (Options AND btWait)<>0 Then Delay(70);
                       Delay(20);
                       UnSelect;
                       Event.What:=evNothing;
                     End;
  End;
End;

{ ==== Module : TButton ==== }

Constructor TButton.Init(X,Y,eComm : Integer ; eTitre : String ;
                         eNbMotif : Byte ; eC1,eC2 : Char);
Begin
  inherited Init(X,Y,Length(eTitre)*8+10,18,eComm,0,btWait+btUpCase,eC1,eC2);
  Ident:='BUTTON';
  Titre:=eTitre;
  NbMotif:=eNbMotif;
  if (NbMotif<>0) Then Inc(Size.X,MotifsC[NbMotif].X+3);
End;

Procedure TButton.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  OutTextXY(P.X+5,P.Y+5,Titre);
  if (NbMotif<>0) Then
    PutImage(P.X+Size.X-MotifsC[NbMotif].X-6,P.Y+5,Motifs[NbMotif]^,NormalPut);
  DrawEnd;
End;

{ ==== Module : Icones ==== }

Constructor TIcone.Init(X,Y : Integer ; eDessin : Byte ; eComL,eComR : Word ;
                        eC1,eC2 : Char ; eDes,eHot : String);
Begin
  inherited Init(X,Y,25,25,7);
  Ident:='ICONE';
  Dessin:=eDessin;
  CommandL:=eComL;
  CommandR:=eComR;
  C1:=eC1;
  C2:=eC2;
  Descrip:=eDes;
  HotKey:=eHot;
End;

Procedure TIcone.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  MoveTo(P.X,P.Y+Size.Y-1);
  LineTo(P.X+Size.X-1,P.Y+Size.Y-1);
  LineTo(P.X+Size.X-1,P.Y);
  if (Etat AND stSelected)<>0
    Then Outline(P.X,P.Y,Size.X-1,Size.Y-1,0,8,15,15)
    Else Outline(P.X,P.Y,Size.X-1,Size.Y-1,15,15,8,0);
  PutImage(P.X+2,P.Y+2,Icones[Dessin]^,NormalPut);
  DrawEnd;
End;

Procedure TIcone.ActionL(Var Event : TEvent);
Begin
  Event.What:=evNothing;
End;

Procedure TIcone.ActionR(Var Event : TEvent);
Var E : TEvent;
Begin
  If (CommandR AND cmInterdite)=0 Then
  Begin
    Outil^.Etat:=Outil^.Etat AND (Not stSelected);
    Outil^.Draw;
    Etat:=Etat OR stSelected;
    Draw;
    E.What:=evCommand;
    E.Command:=CommandR;
    Application^.HandleEvent(E);
    Etat:=Etat AND (Not stSelected);
    Draw;
    Outil^.Etat:=Outil^.Etat OR stSelected;
    Outil^.Draw;
  End;
  Event.What:=evNothing;
End;

Procedure TIcone.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evMouseLDown : If MouseInObjet Then ActionL(Event);
    evMouseRDown : If MouseInObjet Then ActionR(Event);
    evKeyDown    : If (Event.C1=C1) AND (Event.C2=C2) Then ActionL(Event);
  End;
End;

{ ==== Module : TOutil ==== }

Constructor TOutil.Init(X,Y : Integer ; eDessin : Byte ; eCom : Word ;
                        eC1,eC2 : Char ; eDes,eHot : String);
Begin
  inherited Init(X,Y,eDessin,0,eCom,eC1,eC2,eDes,eHot);
End;

Procedure TOutil.ActionL(Var Event : TEvent);
Var E : TEvent;
Begin
  If (Etat AND stSelected)=0 Then
  Begin
    Outil^.Etat:=Outil^.Etat AND (Not stSelected);
    Outil^.Draw;
    Etat:=Etat OR stSelected;
    Draw;
    Outil:=@Self;
    WrkZone^.MouseAspect:=OutilAspect;
    Event.What:=evNothing;
  End;
End;

Procedure TOutil.WrkZoneClic(P : TPoint);
Begin
End;

Procedure TOutil.ElementClic(E : PObjet ; Var Event : TEvent);
Begin
End;

{ ==== Module : TAction ==== }

Procedure TAction.ActionL(Var Event : TEvent);
Var E : TEvent;
Begin
  Outil^.Etat:=Outil^.Etat AND (Not stSelected);
  Outil^.Draw;
  Etat:=Etat OR stSelected;
  Draw;
  E.What:=evCommand;
  E.Command:=CommandL;
  Application^.HandleEvent(E);
  Etat:=Etat AND (Not stSelected);
  Draw;
  Outil^.Etat:=Outil^.Etat OR stSelected;
  Outil^.Draw;
  Event.What:=evNothing;
End;

{ ==== Module : TCoche ==== }

Constructor TCoche.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,14,14,7);
  Ident:='COCHE';
End;

Procedure TCoche.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  Outline(P.X,P.Y,Size.X,Size.Y,15,7,8,0);
  if (Valeur) Then PutImage(P.X+3,P.Y+2,Motifs[3]^,NormalPut);
  DrawEnd;
End;

Procedure TCoche.HandleEvent(Var Event : TEvent);
Var P : TPoint;
Begin
  inherited HandleEvent(Event);
  if Event.What=evMouseLDown Then
    if MouseInObjet Then
    Begin
      Valeur:=Not Valeur;
      DrawBegin;
      MakeGlobal(Origin,P);
      SetFillStyle(SolidFill,7);
      if (Valeur) Then PutImage(P.X+3,P.Y+2,Motifs[3]^,NormalPut)
                  Else Bar(P.X+3,P.Y+2,P.X+9,P.Y+9);
      DrawEnd;
    End;
End;

Procedure TCoche.SetData(Var Rec);
Begin
  Valeur:=Boolean(Rec);
End;

Procedure TCoche.GetData(Var Rec);
Begin
  Boolean(Rec):=Valeur;
End;

Function TCoche.DataSize : Integer;
Begin
  DataSize:=SizeOf(Boolean);
End;

{ ==== Module :  TEdit ==== }

Constructor TEdit.Init(X,Y : Integer ; eLt : Byte);
Begin
  inherited Init(X,Y,eLt*8+8,16,15);
  Ident:='EDIT';
  HelpCtx:='Ligne de saisie';
  Lt:=eLt;
  CPos:=0;
  Ins:=(Toggle AND $80)<>0;
  MouseAspect:=MouseText;
End;

Procedure TEdit.DrawTxt(Deb : Byte);
Var P : TPoint;
Begin
  If (Etat AND stVisible)<>0 Then
  Begin
    DrawBegin;
    MakeGlobal(Origin,P);
    SetFillStyle(SolidFill,15);
    Bar(P.X+4+Deb*8,P.Y+4,P.X+4+Lt*8,P.Y+12);
    SetColor(0);
    OutTextXY(P.X+4+Deb*8,P.Y+4,Copy(Texte,Deb+1,Length(Texte)-Deb));
    DrawEnd;
  End;
End;

Procedure TEdit.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  Outline(P.X,P.Y,Size.X,Size.Y,8,8,7,15);
  SetColor(0);
  OutTextXY(P.X+4,P.Y+4,Texte);
  DrawCursor;
  DrawEnd;
End;

Procedure TEdit.SetData(Var Rec);
Begin
  DrawCursor;
  Texte:=String(Rec);
  CPos:=Length(Texte);
  DrawTxt(0);
  DrawCursor;
End;

Procedure TEdit.GetData(Var Rec);
Begin
  String(Rec):=Texte;
End;

Function TEdit.DataSize : Integer;
Begin
  DataSize:=SizeOf(String);
End;

Procedure TEdit.UnSelect;
Begin
  DrawCursor;
  Etat:=Etat AND (Not stSelected);
End;

Procedure TEdit.Select;
Begin
  Etat:=Etat OR stSelected;
  DrawCursor;
End;

Procedure TEdit.SelectSuiv;
Var O : PObjet;
Label Cherche;
Begin
  UnSelect;
  O:=Suiv;
 Cherche:
  While (O<>NIL) do
  Begin
    if O^.Ident='EDIT' Then
    Begin
      PEdit(O)^.Select;
      Exit;
    End;
    O:=O^.Suiv;
  End;
  O:=@Self;
  While (O^.Prec<>NIL) do O:=O^.Prec;
  Goto Cherche;
End;

Procedure TEdit.SelectPrec;
Var O : PObjet;
Label Cherche;
Begin
  UnSelect;
  O:=Prec;
 Cherche:
  While (O<>NIL) do
  Begin
    if O^.Ident='EDIT' Then
    Begin
      PEdit(O)^.Select;
      Exit;
    End;
    O:=O^.Prec;
  End;
  O:=@Self;
  While (O^.Suiv<>NIL) do O:=O^.Suiv;
  Goto Cherche;
End;

Procedure TEdit.DrawCursor;
Var P : TPoint;
Begin
  if (Etat AND stVisible)<>0 Then
    if (Etat AND stSelected)<>0 Then
    Begin
      DrawBegin;
      MakeGlobal(Origin,P);
      SetWriteMode(XORPut);
      P.X:=P.X+4+8*CPos;
      P.Y:=P.Y+4;
      SetColor(7);
      if Ins Then Begin
                    Line(P.X-1,P.Y-1,P.X-1,P.Y+8);
                    Line(P.X,  P.Y-1,P.X,  P.Y+8);
                  End
             Else Begin
                    Line(P.X-1,P.Y-2,P.X-1,P.Y+8);
                    Line(P.X+8,P.Y-2,P.X+8,P.Y+8);
                    Line(P.X  ,P.Y-2,P.X+7,P.Y-2);
                    Line(P.X  ,P.Y+8,P.X+7,P.Y+8);
                  End;
      SetWriteMode(NormalPut);
      DrawEnd;
    End;
End;

Procedure TEdit.HandleEvent(Var Event : TEvent);
Var NIns : Boolean;
    O    : PObjet;
    P    : TPoint;
    CP   : Integer;
    DoIns: Boolean;
  Procedure InsPlus(C : Char);
  Begin
    If Length(Texte)<Lt Then Insert(C,Texte,CPos+1)
                        Else DoIns:=FALSE;
  End;
  Procedure NoInsPlus(C :Char);
  Begin
    Texte[CPos+1]:=C;
  End;
Begin
  inherited HandleEvent(Event);
  NIns:=(Toggle AND $80)<>0;
  Case Event.What Of
    evToggle    : If Ins<>NIns Then
                  Begin
                    DrawCursor;
                    Ins:=NIns;
                    DrawCursor;
                  End;
   evMouseLDown : If MouseInObjet Then
                  Begin
                    If (Etat AND stSelected)=0 Then
                    Begin            { Active cette zone  la souris }
                      O:=@Self;      { Cherche l'autre zone active   }
                      While (O^.Prec<>NIL) do
                        O:=O^.Prec;
                      While Not (((O^.Etat AND stSelected)<>0) AND
                                 (O^.Ident='EDIT')) do O:=O^.Suiv;
                      PEdit(O)^.UnSelect;
                      Select;
                    End;
                    MakeGlobal(Origin,P);
                    CP:=(Event.Where.X-P.X) div 8;
                    If CP<0 Then Cp:=0;
                    If CP>Length(Texte) Then CP:=Length(Texte);
                    DrawCursor;
                    CPos:=CP;
                    DrawCursor;
                  End;
   evKeyDown    :
      if (Etat AND stSelected)<>0 Then
      Begin
        Case Event.C1 Of
          #0 : Case Event.C2 Of
                 #15 : SelectPrec;                    { Shift-Tab         }
                 #71 : Begin                          { Home              }
                         DrawCursor;
                         CPos:=0;
                         DrawCursor;
                       End;
                 #72 : SelectPrec;                    { Curseur Haut      }
                 #75 : If Cpos>0 Then                 { Curseur Gauche    }
                       Begin
                         DrawCursor;
                         Dec(CPos);
                         DrawCursor;
                       End;
                 #77 : If CPos<Length(Texte) Then     { Curseur Droit     }
                       Begin
                         DrawCursor;
                         Inc(CPos);
                         DrawCursor;
                       End;
                 #79 : Begin                          { End               }
                         DrawCursor;
                         CPos:=Length(Texte);
                         DrawCursor;
                       End;
                 #80 : SelectSuiv;                    { Curseur Bas       }
                 #83 : If Not (Ins AND (CPos=Length(Texte))) Then
                       If Length(Texte)>0 Then
                       Begin                          { Suppr             }
                         DrawCursor;
                         Delete(Texte,CPos+1,1);
                         DrawTxt(CPos);
                         DrawCursor;
                       End;
               Else
                 Exit;
               End;
          #8 : If CPos>0 Then                         { Delete            }
               Begin
                 DrawCursor;
                 Delete(Texte,CPos,1);
                 Dec(CPos);
                 DrawTxt(CPos);
                 DrawCursor;
               End;
          #9 : SelectSuiv;                            { Tab               }
        Else
          If Valid(Event.C1)
          Then
            Begin
              DoIns:=TRUE;
              If CPos=Length(Texte) Then InsPlus(Event.C1)
                                    Else
                If Ins Then InsPlus(Event.C1)
                       Else NoInsPlus(Event.C1);
              If DoIns Then
              Begin
                DrawCursor;
                DrawTxt(CPos);
                if CPos<Length(Texte) Then Inc(CPos);
                DrawCursor;
              End;
            End
          Else Exit;
        End;
        Event.What:=evNothing;
      End;
  End;
End;

Function TEdit.Valid(Var C : Char) : Boolean;
Begin
  Valid:=TRUE;
End;

{ ==== Module : TFiEdit ==== }

Function TFiEdit.Valid(Var C : Char) : Boolean;
Begin
  C:=UpCase(C);
  If C IN ['0'..'9','A'..'Z','_',':','\','.','*','$'] Then Valid:=TRUE
                                                      Else Valid:=FALSE;
End;

{ ==== Module : TReEdit ==== }

Procedure TReEdit.SetData(Var Rec);
Var V  : Real;
    P  : Byte;
Begin
  DrawCursor;
  V:=Real(Rec);
  If V>99999.999999999 Then V:=99999.999999999;
  If V<-99999.999999999 Then V:=-99999.999999999;
  Str(V:0:9,Texte);
  P:=Pos('.',Texte);
  If P<>0 Then Texte[P]:=',';
  While Texte[Length(Texte)]='0' do Dec(Texte[0]);
  If Texte[Length(Texte)]=',' Then Dec(Texte[0]);
  CPos:=Length(Texte);
  DrawTxt(0);
  DrawCursor;
End;

Procedure TReEdit.GetData(Var Rec);
Var V   : Real;
    E,P : Integer;
Begin
  P:=Pos(',',Texte);
  If P<>0 Then Texte[P]:='.';
  Val(Texte,V,E);
  If V>99999.999999999 Then V:=99999.999999999;
  If V<-99999.999999999 Then V:=-99999.999999999;
  Real(Rec):=V;
  If P<>0 Then Texte[P]:=',';
End;

Function TReEdit.DataSize : Integer;
Begin
  DataSize:=SizeOf(Real);
End;

Function TReEdit.Valid(Var C : Char) : Boolean;
Var P : Byte;
Begin
  If Length(Texte)=0 Then Texte[1]:='#';
  Case C Of
    '-'      : If CPos=0 Then
                 If Ins Then
                   If Texte[1]<>'-' Then Valid:=TRUE
                                    Else Valid:=FALSE
                        Else Valid:=TRUE
               Else Valid:=FALSE;
    '0'..'9' : Valid:=TRUE;
    '.',','  : Begin
                 C:=',';
                 P:=Pos(',',Texte);
                 If P=0 Then Valid:=TRUE
                        Else
                   If Ins Then Valid:=FALSE
                          Else
                     If P-1=CPos Then Valid:=TRUE
                                 Else Valid:=FALSE;
               End;
  Else
    Valid:=FALSE;
  End;
End;

Procedure TReEdit.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evKeyDown Then
    If (Etat AND stSelected)<>0 Then
      If Event.C1=#22 Then
      Begin
        SetData(Transfert);
        Event.What:=evNothing;
      End;
End;

{ ==== Module : TIcone2 ==== }

Constructor TIcone2.Init(X,Y : Integer ; eNo : Byte);
Begin
  inherited Init(X,Y,36,36,7);
  No:=eNo;
  Ident:='ICONE2';
End;

Procedure TIcone2.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  OutLine(P.X,P.Y,Size.X,Size.Y,8,0,7,15);
  PutImage(P.X+2,P.Y+2,Icones2[No]^,NormalPut);
  DrawEnd;
End;

{ ==== Module : TCoPalet ==== }

Constructor TCoPalet.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,45,45,7);
  Ident:='COUL:PALET';
  Co:=1;
End;

Procedure TCoPalet.DrawMark;
Var P   : TPoint;
    X,Y : Integer;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  X:=P.X+(Co MOD 4)*11;
  Y:=P.Y+(Co DIV 4)*11;
  SetWriteMode(XorPut);
  SetColor(15);
  Rectangle(X+2,Y+2,X+9,Y+9);
  Rectangle(X+3,Y+3,X+8,Y+8);
  Rectangle(X+4,Y+4,X+7,Y+7);
  Rectangle(X+5,Y+5,X+6,Y+6);
  SetWriteMode(NormalPut);
  Etat:=Etat OR stVisible;
  DrawEnd;
End;

Procedure TCoPalet.Draw;
Var P   : TPoint;
    I,J : Byte;
    X,Y : Integer;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  SetColor(0);
  For J:=0 to 3 do
    For I:=0 to 3 do
    Begin
      X:=P.X+I*11;
      Y:=P.Y+J*11;
      Rectangle(X,Y,X+11,Y+11);
      SetFillStyle(SolidFill,J*4+I);
      Bar(X+1,Y+1,X+10,Y+10);
    End;
  DrawMark;
  DrawEnd;
End;

Procedure TCoPalet.HandleEvent(Var Event : TEvent);
Var P   : TPoint;
    I,J : Byte;
Begin
  inherited HandleEvent(Event);
  If Event.What=evMouseLDown Then
    If MouseInObjet Then
    Begin
      MakeGlobal(Origin,P);
      I:=(Event.Where.X-P.X) div 11;
      J:=(Event.Where.Y-P.Y) div 11;
      If (J>3) OR (I>3) Then Exit;
      DrawMark;
      Co:=J*4+I;
      DrawMark;
    End;
End;

Function TCoPalet.DataSize : Integer;
Begin
  DataSize:=SizeOf(Byte);
End;

Procedure TCoPalet.GetData(Var Rec);
Begin
  Byte(Rec):=Co;
End;

Procedure TCoPalet.SetData(Var Rec);
Begin
  Co:=Byte(Rec);
  If (Etat AND stVisible)<>0 Then Draw;
End;

{ ==== Module : TMenu,TMenuId ==== }

Constructor TMenu.Init(X,Y : Integer ; eTit : String);
Begin
  inherited Init(X,Y,0,0,eTit);
  Ident:='MENU';
End;

Procedure TMenu.Prepare;
Var P       : TPoint;
    M       : PObjet;
    N,LT,LH : Byte;
    Y       : Integer;
Begin
  N:=0;LT:=0;LH:=0;
  M:=Liste;
  While (M<>NIL) do
  Begin
    LT:=MaxByte(Length(PMenuId(M)^.Texte),LT);
    LH:=MaxByte(Length(PMenuId(M)^.Hot),LH);
    Inc(N);
    M:=M^.Suiv;
  End;
  Size.X:=(LT+LH)*8+17;
  Size.Y:=N*16+16;
  Y:=16;
  M:=Liste;
  While (M<>NIL) do
  Begin
    M^.Origin.Y:=Y;
    M^.Size.X:=Size.X;
    PMenuId(M)^.PHot:=LT*8+13;
    Inc(Y,16);
    M:=M^.Suiv;
  End;
End;

Procedure TMenu.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  TGroup.Draw;
  MakeGlobal(Origin,P);
  SetFillStyle(SolidFill,0);
  Bar(P.X,P.Y,P.X+Size.X-2,P.Y+13);
  Outline(P.X,P.Y,Size.X,16,15,0,8,0);
  SetColor(15);
  OutTextXY(P.X+((Size.X-1-TextWidth(Titre)) div 2),P.Y+4,Titre);
  DrawEnd;
End;

Procedure TMenu.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evCommand    : Begin SetEvent(Event); ExitCode:=exOK; End;
    evMouseLDown : ExitCode:=exAnnule;
    evKeyDown    : If (Event.C1=#27) Then ExitCode:=exAnnule
                                     Else Exit;
  Else
    Exit;
  End;
  Event.What:=evNothing;
End;

Constructor TMenuId.Init(eTex,eHot : String ; eC1,eC2 : Char ; eComm : Integer);
Begin
  inherited Init(0,0,0,16,eComm,0,0,eC1,eC2);
  Ident:='MENU:ITEM';
  Texte:=eTex;
  Hot:=eHot;
End;

Procedure TMenuId.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  If (Commande AND cmInterdite)<>0 Then SetColor(8) Else SetColor(0);
  OutTextXY(P.X+3,P.Y+4,Texte);
  OutTextXY(P.X+PHot,P.Y+4,Hot);
  DrawEnd;
End;

{ ==== Module : TRadio, TRadItem ==== }

Constructor TRadio.Init;
Begin
  inherited Init(-1,-1,0,0,0);
  Ident:='RADIO';
End;

Function TRadio.DataSize : Integer;
Begin
  DataSize:=SizeOf(Byte);
End;

Procedure TRadio.SetData(Var Rec);
Var I,R : Byte;
    P   : PObjet;
Begin
  R:=Byte(Rec);
  I:=0;
  P:=Liste;
  While (P<>NIL) do
  Begin
    Inc(I);
    If R=I
    Then
      Begin
        If (P^.Etat AND stSelected)=0 Then
        Begin
          P^.Etat:=P^.Etat OR stSelected;
          If (P^.Etat AND stVisible)<>0 Then P^.Draw;
        End;
      End
    Else
      Begin
        If (P^.Etat AND stSelected)<>0 Then
        Begin
          P^.Etat:=P^.Etat AND (Not stSelected);
          If (P^.Etat AND stVisible)<>0 Then P^.Draw;
        End;
      End;
    P:=P^.Suiv;
  End;
End;

Procedure TRadio.GetData(Var Rec);
Var I,R : Byte;
    P   : PObjet;
Begin
  I:=0;
  P:=Liste;
  While (P<>NIL) do
  Begin
    Inc(I);
    If (P^.Etat AND stSelected)<>0 Then R:=I;
    P:=P^.Suiv;
  End;
  Byte(Rec):=R;
End;

Constructor TRadItem.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,14,14,7);
  Ident:='RADIO:ELT';
End;

Procedure TRadItem.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  If (Etat AND stSelected)<>0 Then PutImage(P.X,P.Y,Motifs[14]^,NormalPut)
                              Else PutImage(P.X,P.Y,Motifs[15]^,NormalPut);
  Etat:=Etat OR stVisible;
  DrawEnd;
End;

Procedure TRadItem.HandleEvent(Var Event : TEvent);
Var P : PObjet;
    E : Boolean;
Begin
  inherited HandleEvent(Event);
  If Event.What=evMouseLDown Then
    If MouseInObjet Then
      If (Etat AND stSelected)=0 Then
      Begin
        P:=Owner^.Liste;
        While P<>NIL do
        Begin
          If (P^.Etat AND stSelected)<>0 Then
          Begin
            P^.Etat:=P^.Etat AND (Not stSelected);
            P^.Draw;
          End;
          P:=P^.Suiv;
        End;
        Etat:=Etat OR stSelected;
        Draw;
      End;
End;

{ ==== Module : THotKey ==== }

Constructor THotKey.Init(eC1,eC2 : Char ; eComm : Word);
Begin
  inherited Init(0,0,0,0,0);
  C1:=eC1;
  C2:=eC2;
  Comm:=eComm;
  Ident:='Hot-Key';
End;

Procedure THotKey.Draw;
Begin
End;

Procedure THotKey.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evKeyDown Then
    If (Event.C1=C1) AND (Event.C2=C2) Then
    Begin
      SetCommand(Comm);
      Event.What:=evNothing;
    End;
End;

BEGIN
  Transfert:=0;
END.