{**********************************************************}
{                                                          }
{                   Projet SoftOptique                     }
{                   Librairie d'outils                     }
{    TCoord   : Tmoin de coordonne                       }
{    TNomFich : Tmoin du nom de fichier                   }
{    TToggle  : Tmoin de touche toggle                    }
{    THeure   : Module d'heure                             }
{    TStLine  : Ligne d'tat                               }
{    TBrowser : Le browser de fichier                      }
{    TBrowCol : Une colonne du browser (usage interne)     }
{    TConfig  : Affichage de la configuration              }
{    TDskErr  : Indique une erreur d'accs disque          }
{    TVerif   : Vrifie la modification du fichier         }
{    TCalcul  : Calculatrice                               }
{                                                          }
{   Debut du projet : 10.04.93                   cm0=100   }
{   Mise A Jour     : 02.06.93                             }
{                                                          }
{**********************************************************}

UNIT Outils;

INTERFACE

Uses Drivers,ObjetAbs,Objet;

Const
     brSelect     = $40;
     cmOutils     = 100;
     cmBrowseUp   = cmOutils+01;
     cmBrowseDown = cmOutils+02;
     cmBrowseLeft = cmOutils+03;
     cmBrowseRigh = cmOutils+04;
     cmDiskBut    = cmOutils+05;
     cmConfig     = cmOutils+06;
     cmHelp       = cmOutils+07;
     cmNomFichier = cmOutils+08;
     cmModif      = cmOutils+09;
     cmCalculator = cmOutils+10;
     cmCalcAction = cmOutils+11;
     cmDateHeure  = cmOutils+12;
     cmDatHeurBut = cmOutils+13;

Type PCoord   = ^TCoord;
     PNomFich = ^TNomFich;
     PToggle  = ^TToggle;
     PHeure   = ^THeure;
     PStLine  = ^TStLine;
     PBrowser = ^TBrowser;
     PBrowCol = ^TBrowCol;
     PConfig  = ^TConfig;
     PQuitte  = ^TQuitte;
     PDskErr  = ^TDskErr;
     PVerif   = ^TVerif;
     PCalcul  = ^TCalcul;
     PDatHeur = ^TDatHeur;
     TCoord   = Object(TObjet)
                  Tpe : Byte;
                  Val : Real;
                  Constructor Init(X,Y : Integer ; eTpe : Byte);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TNomFich = Object(TObjet)
                  OldModif : Boolean;
                  Constructor Init(X,Y : Integer);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TToggle  = Object(TObjet)
                  Mask : Integer;
                  Txt  : String;
                  Val  : Integer;
                  Constructor Init(X,Y,eMask : Integer ; eTxt : String);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     THeure   = Object(TObjet)
                  H,M : Integer;
                  Constructor Init(X,Y : Integer);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TStLine  = Object(TGroup)
                  Constructor Init(X,Y,L,H : Integer);
                  Procedure   Draw;                                  Virtual;
                End;
     BrowsRec = Record                           { Type pour effectuer les   }
                  Chemin    : String;            { SetData, GetData avec     }
                  Fichier   : String;            { le browser de fichier     }
                  Recherche : String;
                End;
     TBrowser = Object(TDialog)
                  Data : BrowsRec;
                  Cols : Array[1..4] Of PBrowCol;
                  Deb  : Byte;
                  Constructor Init(eTitre : String ; eIco2 : Byte);
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   Draw;                                  Virtual;
                  Procedure   DispatcheChemin;
                  Procedure   InitCols;
                  Procedure   ResetDskItems;
                End;
     TBrowCol = Object(TGroup)
                  Titre : String;
                  No    : Byte;
                  Path  : String;            { Le Chemin avant cette colonne }
                  Tab   : DskItemTb;         { Tableau des Items rellement  }
                  NbItem: Byte;              { Visibles (aprs Recherche)    }
                  DbItem: Byte;              { 1er Item visible              }
                  TimeClic : LongInt;        { Date du dernier clic          }
                  Constructor Init(eNo : Byte);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   SetCont(eCont : PDskItem ; eTitre,ePath : String);
                  Procedure   DrawListe;
                  Procedure   DrawTitre;
                End;
     TConfig  = Object(TDialog)
                  IconesH : Integer;
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TQuitte  = Object(TDialog)
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TDskErr  = Object(TDialog)
                  Constructor Init(X,Y : Integer);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TVerif   = Object(TDialog)
                  Constructor Init(X,Y : Integer);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TCalcul  = Object(TDialog)
                  Number  : String;
                  Sign    : Char;
                  Status  : Integer;
                  Operator: Integer;
                  Operand : Real;
                  Memory  : Real;
                  Constructor Init;
                  Procedure   DrawDisplay;
                  Procedure   Clear;
                  Procedure   CalcKey(Key : Integer);
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TDatHeur = Object(TDialog)
                  Jour,Mois : Integer;
                  Heur,Min  : Integer;
                  GMT       : Integer;
                  Annee     : Integer;
                  RealMin   : Integer;
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   DrawElt(N : Byte);
                End;

IMPLEMENTATION

Uses Crt,Dos,Graph;

{ ==== Module : TCoord ==== }

Constructor TCoord.Init(X,Y : Integer ; eTpe : Byte);
Begin
  inherited Init(X,Y,96,16,3);
  Ident:='StLn:COORD';
  HelpCtx:='Tmoin de coordonne';
  Tpe:=eTpe;
  Val:=1E30;
End;

Procedure TCoord.Draw;
Var P : TPoint;
    S : String[2];
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  OutLine(P.X,P.Y,Size.X,Size.Y,8,3,3,15);
  SetColor(0);
  Case Tpe Of
    1 : S:='X:';
    2 : S:='Y:';
  End;
  OutTextXY(P.X+4,P.Y+4,S);
  DrawEnd;
End;

Procedure TCoord.HandleEvent(Var Event : TEvent);
Var S : String;
    V : Real;
    P : TPoint;
Begin
  inherited HandleEvent(Event);
  If (Event.What AND evMouseMove)<>0 Then
  Begin
    Case Tpe Of
      1 : V:=Rx(Event.Where.X);
      2 : V:=Ry(Event.Where.Y);
    End;
    If V<>Val Then
    Begin
      DrawBegin;
      MakeGlobal(Origin,P);
      SetFillStyle(SolidFill,3);
      Bar(P.X+20,P.Y+4,P.X+91,P.Y+11);
      Str(V:9:2,S);
      SetColor(0);
      OutTextXY(P.X+20,P.Y+4,S);
      DrawEnd;
      Val:=V;
    End;
  End;
End;

{ ==== Module : TNomFich ==== }

Constructor TNomFich.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,104,8,7);
  Ident:='NomFich';
  HelpCtx:='Tmoin de nom de fichier';
End;

Procedure TNomFich.Draw;
Var P : TPoint;
    C : DirStr;
    N : NameStr;
    E : ExtStr;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  If NomFichier<>'' Then FSplit(NomFichier,C,N,E)
                    Else Begin N:='SANS_NOM'; E:='.OPT'; End;
  C:=N+E;
  If Modif Then C:=C+'*';
  OutTextXY(P.X,P.Y,C);
  OldModif:=Modif;
  DrawEnd;
End;

Procedure TNomFich.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmNomFichier : Draw;
      cmModif      : If OldModif<>Modif Then Draw;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

{ ==== Module : TToggle ==== }

Constructor TToggle.Init(X,Y,eMask : Integer ; eTxt : String);
Begin
  inherited Init(X,Y,8*Length(eTxt)+8,16,3);
  Ident:='StLn:TOGGL';
  Mask:=eMask;
  Txt:=eTxt;
  Val:=$FF;
End;

Procedure TToggle.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  OutLine(P.X,P.Y,Size.X,Size.Y,8,3,3,15);
  SetColor(0);
  DrawEnd;
End;

Procedure TToggle.HandleEvent(Var Event : TEvent);
Var P : TPoint;
Begin
  inherited HandleEvent(Event);
  If (Event.What AND evToggle)<>0 Then
    If (Toggle AND Mask<>Val) Then
    Begin
      DrawBegin;
      MakeGlobal(Origin,P);
      SetFillStyle(SolidFill,3);
      Bar(P.X+4,P.Y+4,P.X+Size.X-5,P.Y+Size.Y-5);
      SetColor(0);
      Val:=Toggle AND Mask;
      If Val<>0 Then OutTextXY(P.X+4,P.Y+4,Txt);
      DrawEnd;
    End;
End;

{ ==== Module : THeure ==== }
Constructor THeure.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,68,16,0);
  Ident:='HORLOGE';
  HelpCtx:='Horloge';
  H:=30;
  M:=70;
End;

Procedure THeure.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  OutLine(P.X,P.Y,Size.X,Size.Y,8,0,0,15);
  SetColor(11);
  OutTextXY(P.X+18,P.Y+4,':');
  OutTextXY(P.X+42,P.Y+4,':');
  DrawEnd;
End;

Procedure THeure.HandleEvent(Var Event : TEvent);
Var P : TPoint;
  Procedure Aff(X,V : Integer);
  Begin
    PutImage(P.X+X,P.Y+2,Chiffres[V div 10]^,NormalPut);
    PutImage(P.X+X+8,P.Y+2,Chiffres[V mod 10]^,NormalPut);
  End;
Begin
  MakeGlobal(Origin,P);
  If Event.What=evTime Then
  Begin
    DrawBegin;
    MakeGlobal(Origin,P);
    Aff(50,Seconde);
    If (M<>Minute) Then
    Begin
      M:=Minute;
      Aff(26,Minute);
    End;
    If (H<>Heure) Then
    Begin
      H:=Heure;
      Aff(2,Heure);
    End;
    DrawEnd;
  End;
End;

{ ==== Module : TStLine ==== }

Constructor TStLine.Init(X,Y,L,H : Integer);
Begin
  inherited Init(X,Y,L,H,7);
  Ident:='STLINE';
  HelpCtx:='Ligne d''tat';
  Insert(New(PCoord,Init(2,3,1)));
  Insert(New(PCoord,Init(100,3,2)));
  Insert(New(PNomFich,Init(200,7)));
  Insert(New(PToggle,Init(GetMaxX-34,3,ToggleNum,'NUM')));
  Insert(New(PToggle,Init(GetMaxX-76,3,ToggleCaps,'CAPS')));
  Insert(New(PToggle,Init(GetMaxX-134,3,ToggleIns,'Insert')));
  Insert(New(PToggle,Init(GetMaxX-168,3,ToggleAlt,'Alt')));
  Insert(New(PToggle,Init(GetMaxX-210,3,ToggleCtrl,'Ctrl')));
  Insert(New(PHeure, Init(GetMaxX-280,3)));
End;

Procedure TStLine.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  Line(P.X,P.Y,P.X+Size.X-1,P.Y);
  DrawEnd;
End;

{ ==== Module : Browser de fichier ==== }

Type PBrowBut = ^TBrowBut;
     PBrowLec = ^TBrowLec;
     TBrowBut = Object(TAbsBut)
                  Tpe : Byte;
                  Constructor Init(eTpe,No : Byte);
                  Procedure   Draw;                                  Virtual;
                End;
     TBrowLec = Object(TAbsBut)
                  No,Tpe : Byte;
                  Constructor Init(X,Y : Integer ; eNo,eTpe : Byte);
                  Procedure   Draw;                                  Virtual;
                End;


{ ---- TBrowLec ---- }
Constructor TBrowLec.Init(X,Y : Integer ; eNo,eTpe : Byte);
Begin
  Case eTpe Of
    1 : inherited Init(X+16,Y  ,32,16,cmDiskBut,eNo,0,#0,#0);
    2 : inherited Init(X+16,Y+3,24,10,cmDiskBut,eNo,0,#0,#0);
    3 : inherited Init(X+16,Y+2,27,13,cmDiskBut,eNo,0,#0,#0);
  End;
  No:=eNo;
  Tpe:=eTpe;
End;

Procedure TBrowLec.Draw;
Var P : TPoint;
    S : String[2];
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  S:='?:'; S[1]:=Chr(64+No);
  Case Tpe Of
    1 : Begin
          OutTextXY(P.X-16,P.Y+4,S);
          PutImage(P.X+2,P.Y+2,Motifs[12]^,NormalPut);
        End;
    2 : Begin
          OutTextXY(P.X-16,P.Y+1,S);
          PutImage(P.X+2,P.Y+2,Motifs[13]^,NormalPut);
        End;
    3 : Begin
          OutTextXY(P.X-16,P.Y+2,S);
          PutImage(P.X+2,P.Y+2,Motifs[11]^,NormalPut);
        End;
  End;
  DrawEnd;
End;

{ ---- TBrowBut ---- }
Constructor TBrowBut.Init(eTpe,No : Byte);
Begin
  Case eTpe Of
    1 : Begin
          inherited Init(3, 84, 14,53,cmBrowseLeft,0, 0     ,#0,#0);
          MouseAspect:=MouseLeft;
        End;
    2 : Begin
          inherited Init(3, 139,14,53,cmBrowseRigh,0, 0     ,#0,#0);
          MouseAspect:=MouseRight;
        End;
    3 : Begin
          inherited Init(57,126,55,14,cmBrowseUp  ,No,btAuto,#0,#0);
          MouseAspect:=MouseUp;
        End;
    4 : Begin
          inherited Init(0, 126,55,14,cmBrowseDown,No,btAuto,#0,#0);
          MouseAspect:=MouseDown;
        End;
  End;
  Tpe:=eTpe;
  Ident:='BROWSE:BUT';
End;

Procedure TBrowBut.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  PutImage(P.X+((Size.X-MotifsC[Tpe+4].X) div 2)-1,
           P.Y+((Size.Y-MotifsC[Tpe+4].Y) div 2)-1,
           Motifs[Tpe+4]^,NormalPut);
  DrawEnd;
End;

{ ---- TBrowCol ---- }

Constructor TBrowCol.Init(eNo : Byte);
Var I : Byte;
Begin
  inherited Init(19+(eNo-1)*114,68,112,142,7);
  Ident:='BROWSE:COL';
  No:=eNo;
  DbItem:=1;
  Insert(New(PBrowBut,Init(3,No)));
  Insert(New(PBrowBut,Init(4,No)));
End;

Procedure TBrowCol.DrawTitre;
Var P : TPoint;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  SetFillStyle(SolidFill,8);
  Bar(P.X+2,P.Y+2,P.X+109,P.Y+11);
  SetColor(15);
  OutTextXY(P.X+((112-Length(Titre)*8) div 2)-1,P.Y+4,Titre);
  DrawEnd;
End;

Procedure TBrowCol.DrawListe;
Var P   : TPoint;
    I   : Byte;
    N,M : Byte;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  I:=DbItem;N:=0;SetColor(0);
  SetFillStyle(SolidFill,7);
  M:=9;
  While (I<=NbItem) AND (N<10) do
  Begin
    If (Tab[I]^.Attr AND brSelect)<>0 Then
    Begin
      SetFillStyle(SolidFill,15);
      M:=10;
    End;
    Bar(P.X+2,P.Y+20+N*10,P.X+109,P.Y+29+N*10);
    OutTextXY(P.X+4,P.Y+21+N*10,Tab[I]^.Nom);
    if (Tab[I]^.Attr AND Directory)<>0 Then
      PutImage(P.X+100,P.Y+21+N*10,Motifs[M]^,NormalPut);
    If (Tab[I]^.Attr AND brSelect)<>0 Then
    Begin
      SetFillStyle(SolidFill,7);
      M:=9;
    End;
    Inc(I);
    Inc(N);
  End;
  While (N<10) do
  Begin
    Bar(P.X+2,P.Y+20+N*10,P.X+109,P.Y+29+N*10);
    Inc(N);
  End;
  DrawEnd;
End;

Procedure TBrowCol.Draw;
Var P   : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  OutLine(P.X,P.Y,112,14,8,0,7,15);
  OutLine(P.X,P.Y+16,112,108,8,0,7,15);
  DrawTitre;
  DrawListe;
  DrawEnd;
End;

Procedure TBrowCol.SetCont(eCont : PDskItem ; eTitre,ePath : String);
Var R : String[3];
  Function CalcRang : Integer;     { Calcule le rang de l'DskItem Select }
  Var RD,RI : Byte;
      I     : Byte;
  Begin
    RI:=0;
    I:=1;
    While I<=NbItem do
    Begin
      If I=DbItem Then RD:=I;
      If (Tab[I]^.Attr AND brSelect)<>0 Then RI:=I;
      Inc(I);
    End;
    if RI=0 Then CalcRang:=1
            Else CalcRang:=RI-RD+1;
  End;
  Function FitRecherche(P : PDskItem) : Boolean;
  Var Result : Boolean;
      I      : Byte;
      Comp   : String[3];
  Label Fin;
  Begin
    Result:=TRUE;                 { Par dfaut, c'est bon                    }
    If (P^.Attr AND Directory)<>0 Then Goto Fin; { On garde les rpertoires  }
    Comp:=Copy(P^.Nom,10,3);      { Chane  examiner                        }
    For I:=1 to 3 do              { Examine les 3 caractres                 }
    Case R[I] Of
      '*' : goto Fin;             { Tout est bon aprs le *                  }
      '$' : ;                     { C'est bon juste pour ce caractre        }
    Else
      If R[I]<>Comp[I] Then       { Si a ne colle pas                       }
      Begin
        Result:=FALSE;            { On le dit                                }
        goto Fin;                 { Et on sort                               }
      End;
    End;
   Fin:
    FitRecherche:=Result;
  End;
Begin
  { Charge le tableau avec les Items qui correspondent  Recherche }
  R:=PBrowser(Owner)^.Data.Recherche;
  NbItem:=0;
  While (eCont<>NIL) do
  Begin
    If FitRecherche(eCont) Then
    Begin
      Inc(NbItem);
      Tab[NbItem]:=eCont;
    End;
    eCont:=eCont^.Suiv;
  End;
  Path:=ePath;
  While (CalcRang<1) do Dec(DbItem);
  While (CalcRang>10) do Inc(DbItem);
  Titre:=eTitre;
  If (Etat AND stVisible)<>0 Then
  Begin
    DrawTitre;
    DrawListe;
  End;
End;

Procedure TBrowCol.HandleEvent(Var Event : TEvent);
Var P   : TPoint;
    I,N : Byte;
    D   : PDskItem;
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evCommand    : If Event.InfoInt=No Then
                   Begin
                     Case Event.Command Of
                       cmBrowseUp   : If DbItem>1 Then
                                      Begin
                                        Dec(DbItem);
                                        DrawListe;
                                      End;
                       cmBrowseDown : If DbItem<NbItem Then
                                      Begin
                                        Inc(DbItem);
                                        DrawListe;
                                      End;
                     Else
                       Exit;
                     End;
                     Event.What:=evNothing;
                   End;
    evMouseLDown : Begin
                     MakeGlobal(Origin,P);
                     if (Event.Where.X>=P.X+2) AND (Event.Where.X<P.X+110) AND
                        (Event.Where.Y>=P.Y+20) AND (Event.Where.Y<P.Y+119) Then
                     Begin
                       N:=(Event.Where.Y-P.Y-19) div 10;
                       N:=N+DbItem;
                       If N>NbItem Then Exit;
                       If (Tab[N]^.Attr AND Directory)<>0
                       Then
                         With PBrowser(Owner)^ do
                         Begin
                           GetData(Data);
                           Data.Chemin:=Path+Tab[N]^.Nom+'\';
                           SetData(Data);
                           If No=4 Then
                           Begin
                             Inc(Deb);
                             For I:=1 to 3 do
                               Cols[I]^.DbItem:=Cols[I+1]^.DbItem;
                           End;
                           ResetDskItems;
                           InitCols;
                         End
                       Else
                         If ((Tab[N]^.Attr AND brSelect)<>0) AND
                            (GetLongTime-TimeClic<50)
                         Then
                           Begin
                             Event.What:=evCommand;
                             Event.Command:=cmOK;
                             SetEvent(Event);
                           End
                         Else
                           With PBrowser(Owner)^ do
                           Begin
                             GetData(Data);
                             Data.Fichier:=Tab[N]^.Nom;
                             If Data.Chemin<>Path Then
                             Begin
                               Data.Chemin:=Path;
                               For I:=No+1 to 4 do
                                 Cols[I]^.SetCont(NIL,'','');
                             End;
                             SetData(Data);
                             For I:=1 to NbItem do
                               Tab[I]^.Attr:=Tab[I]^.Attr AND (Not brSelect);
                             Tab[N]^.Attr:=Tab[N]^.Attr OR brSelect;
                             Etat:=Etat OR stVisible;
                             DrawTitre;
                             DrawListe;
                             TimeClic:=GetLongTime;
                           End;
                       Event.What:=evNothing;
                     End;
                   End;
  End;
End;

{ ---- TBrowser ---- }

Constructor TBrowser.Init(eTitre : String ; eIco2 : Byte);
Var E  : PFiEdit;
    P  : PLecteur;
    XL : Integer;
Begin
  inherited Init(50,50,476,235,eTitre);
  Ident:='BROWSER';
  Insert(New(PButton,Init(345,212,cmOK,    'OK',     btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(395,212,cmAnnule,'Annuler',btMotifEsc  ,#27,#0)));
  Insert(New(PIcone2,Init(6,23,eIco2)));
  E:=New(PFiEdit,Init(119,23,43));
  Insert(E);
  Insert(New(PFiEdit,Init(119,43,12)));
  Insert(New(PFiEdit,Init(439,43,3)));
  For XL:=1 to 4 do
  Begin
    Cols[XL]:=New(PBrowCol,Init(XL));
    Insert(Cols[XL]);
  End;
  Insert(New(PBrowBut,Init(1,0)));
  Insert(New(PBrowBut,Init(2,0)));
  P:=Lecteurs;
  XL:=6;
  While P<>NIL do
  Begin
    Insert(New(PBrowLec,Init(XL,213,P^.No,P^.Tpe)));
    Case P^.Tpe Of
      1 : Inc(XL,53);
      2 : Inc(XL,45);
      3 : Inc(XL,48);
    End;
    P:=P^.Suiv;
  End;
  E^.Select;
  GetDir(0,Data.Chemin);
  EnterDiskDir;
  Data.Recherche:='OPT';
  Data.Fichier:='';
  SetData(Data);
  Deb:=0;
  DispatcheChemin;
End;

Procedure TBrowser.HandleEvent(Var Event : TEvent);
Var S    : String;
    Sauv : BrowsRec;
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmOK         : ExitCode:=exOK;
      cmAnnule     : ExitCode:=exAnnule;
      cmDiskBut    : Begin
                       Sauv:=Data;
                       GetData(Data);
                       If Ord(Sauv.Chemin[1])-64=Event.InfoInt
                       Then
                         Begin
                           ChDir(Data.Chemin);
                           If IOResult<>0
                           Then
                             Begin
                               Data:=Sauv;
                               SetData(Data);
                               BeepWrong;
                               Exit;
                             End
                           Else
                             If Ord(Data.Chemin[1])-64<>Event.InfoInt Then
                             Begin
                               DoneDskItems;
                               InitDskItems;
                             End;
                         End
                       Else
                         Begin
                           If Ord(Data.Chemin[1])-64<>Event.InfoInt Then
                             GetDir(Event.InfoInt,Data.Chemin);
                           ChDir(Data.Chemin);
                           If IOResult<>0 Then
                           Begin
                             Data:=Sauv;
                             SetData(Data);
                             BeepWrong;
                             Exit;
                           End;
                           DoneDskItems;
                           InitDskItems;
                         End;
                       SetData(Data);
                       ResetDskItems;
                       DispatcheChemin;
                     End;
      cmBrowseLeft : If (Deb>0) Then
                     Begin
                       Dec(Deb);
                       ResetDskItems;
                       InitCols;
                     End;
      cmBrowseRigh : If Cols[2]^.NbItem<>0 Then
                     Begin
                       Inc(Deb);
                       ResetDskItems;
                       InitCols;
                     End;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

Procedure TBrowser.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+47,P.Y+27,'Chemin:');
  OutTextXY(P.X+47,P.Y+47,'Fichier:');
  OutTextXY(P.X+351,P.Y+47,'Recherche:');
  SetColor(8); Line(P.X+1,P.Y+64,P.X+Size.X-2,P.Y+64);
  SetColor(15); Line(P.X+1,P.Y+65,P.X+Size.X-2,P.Y+65);
  DrawEnd;
End;

Procedure TBrowser.DispatcheChemin;
Var S   : String;
    N,P : Integer;
Begin
  S:=Copy(Data.Chemin,4,Length(Data.Chemin)-3);   { Enlve le drive '?:\'    }
  N:=0;
  If S<>'' Then
  Begin
    Inc(N);                                   { Cherche le nombre de niveaux }
    For P:=1 to Length(S) do                  { de sous-rpertoires dans le  }
      If S[P]='\' Then Inc(N);                { chemin d'accs               }
  End;
  Dec(N);                                     { Ne compte pas le '\' final   }
  If Deb+3<N Then Deb:=N-3;                   { Il faut voir la fin          }
  InitCols;                                   { Initialise les 4 colonnes    }
End;

Procedure TBrowser.InitCols;
Var N,P,X  : Byte;
    S,T,Ch : String;
    I,I2   : PDskItem;
    Path   : String;
Begin
  S:=Data.Chemin;
  S:=Copy(S,4,Length(S)-3);
  T:=Copy(Data.Chemin,1,3);
  Path:='';
  I:=DskRoot;
  For N:=1 to Deb do
  Begin
    Path:=Path+T;
    P:=Pos('\',S);
    T:=Copy(S,1,P-1);
    S:=Copy(S,P+1,Length(S));
    While (I^.Nom<>T) do I:=I^.Suiv;
    T:=T+'\';
    I:=I^.Liste;
  End;
  X:=1;
  While (X<=4) AND (S<>'') do
  Begin
    Path:=Path+T;
    P:=Pos('\',S);
    Ch:=Copy(S,1,P-1);
    S:=Copy(S,P+1,Length(S));
    I2:=I;
    While (I2^.Nom<>Ch) do I2:=I2^.Suiv;
    I2^.Attr:=I2^.Attr OR brSelect;
    Cols[X]^.SetCont(I,T,Path);
    T:=Ch+'\';
    I:=I2^.Liste;
    Inc(X);
  End;
  If (X<=4) Then
  Begin
    Path:=Path+T;
    Cols[X]^.SetCont(I,T,Path);
    Inc(X);
  End;
  While X<=4 do
  Begin
    Cols[X]^.SetCont(NIL,'','');
    Inc(X);
  End;
End;

Procedure TBrowser.ResetDskItems;
  Procedure Reset(I : PDskItem);
  Begin
    While (I<>NIL) do
    Begin
      I^.Attr:=I^.Attr AND (Not brSelect);
      If (I^.Attr AND Directory)<>0 Then Reset(I^.Liste);
      I:=I^.Suiv;
    End;
  End;
Begin
  Reset(DskRoot);
End;

{ ==== Affichage de la configuration ==== }

Constructor TConfig.Init;
Var P : PLecteur;
Begin
  P:=Lecteurs;
  IconesH:=0;
  While (P<>NIL) do
  Begin
    Case P^.Tpe Of
      1 : Inc(IconesH,16+5);
      2 : Inc(IconesH,10+5);
      3 : Inc(IconesH,13+5);
    End;
    P:=P^.Suiv;
  End;
  If IconesH<59 Then IconesH:=59;
  inherited Init(50,50,348,174+IconesH,'Configuration');
  Insert(New(PButton,Init(291,147+IconesH,cmOK,'OK',btMotifEnter,#13,#0)));
  Insert(New(PIcone2,Init(9,35,7)));
End;

Procedure TConfig.Draw;
Var P       : TPoint;
    L       : PLecteur;
    Y       : Integer;
    S,S1    : String;
    A,M,Q,J : Word;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  { Case : Matriel }
  OutLine(P.X+53,P.Y+29,286,51,8,15,8,15);
  SetFillStyle(SolidFill,7);
  Bar(P.X+63,P.Y+26,P.X+134,P.Y+33);
  SetColor(0);
  OutTextXY(P.X+67,P.Y+26,'Matriel');
  Case GrCarte Of
    EGA   : S:='EGA';
    EGA64 : S:='EGA (64Ko de RAM)';
    VGA   : S:='VGA';
  End;
  OutTextXY(P.X+60,P.Y+39,'Type de PC      : '+TypePC);
  OutTextXY(P.X+60,P.Y+52,'Processeur      : '+Processor);
  OutTextXY(P.X+60,P.Y+65,'Carte graphique : '+S);
  { Case : DOS }
  OutLine(P.X+9,P.Y+91,182,IconesH+12,8,15,8,15);
  SetColor(0);
  Str(DosVer1,S);Str(DosVer2,S1);
  S:='DOS '+S+'.'+S1;
  Bar(P.X+19,P.Y+88,P.X+Length(S)*8+26,P.Y+95);
  OutTextXY(P.X+23,P.Y+88,S);
  L:=Lecteurs;
  Y:=P.Y+101;
  While (L<>NIL) do
  Begin
    S:=Chr(L^.No+64);
    Case L^.Tpe Of
      1 : Begin
            OutLine(P.X+16,Y,32,16,15,7,8,0);
            PutImage(P.X+18,Y+2,Motifs[12]^,NormalPut);
            OutTextXY(P.X+56,Y+4,S+': Disque dur');
            Inc(Y,16+5);
          End;
      2 : Begin
            OutLine(P.X+16,Y,24,10,15,7,8,0);
            PutImage(P.X+18,Y+2,Motifs[13]^,NormalPut);
            OutTextXY(P.X+56,Y+1,S+': Disquette 3"');
            Inc(Y,10+5);
          End;
      3 : Begin
            OutLine(P.X+16,Y,27,13,15,7,8,0);
            PutImage(P.X+18,Y+2,Motifs[11]^,NormalPut);
            OutTextXY(P.X+56,Y+2,S+': Disquette 5"');
            Inc(Y,13+5);
          End;
    End;
    L:=L^.Suiv;
  End;
  { Case : AppPath }
  OutLine(P.X+9,P.Y+114+IconesH,330,25,8,15,8,15);
  SetColor(0);
  Bar(P.X+19,P.Y+111+IconesH,P.X+250,P.Y+118+IconesH);
  OutTextXY(P.X+23,P.Y+111+IconesH,'Chemin d''accs  SoftOptique');
  S:=AppPath;
  If Length(S)>39 Then S:='..'+Copy(S,Length(S)-36,37);
  OutTextXY(P.X+16,P.Y+124+IconesH,S);
  { Case : Mmoire }
  OutLine(P.X+199,P.Y+91,140,25,8,15,8,15);
  SetColor(0);
  Bar(P.X+209,P.Y+88,P.X+272,P.Y+95);
  OutTextXY(P.X+213,P.Y+88,'Mmoire');
  Str(MemAvail div 1024,S);
  OutTextXY(P.X+206,P.Y+101,'Libre : '+S+' Ko');
  { Case : Date }
  OutLine(P.X+199,P.Y+127,140,IconesH+12-36,8,15,8,15);
  SetColor(0);
  Bar(P.X+209,P.Y+124,P.X+248,P.Y+131);
  OutTextXY(P.X+213,P.Y+124,'Date');
  GetDate(A,M,Q,J);
  OutTextXY(P.X+206,P.Y+137,NomJour[J]+',');
  Str(Q,S);
  OutTextXY(P.X+206,P.Y+147,S+' '+NomMois[M]);
  DrawEnd;
End;

Procedure TConfig.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evCommand : If Event.Command=cmOK Then
                Begin
                  ExitCode:=exOK;
                  Event.What:=evNothing;
                End;
    evKeyDown : if Event.C1=#27 Then
                Begin
                  ExitCode:=exOK;
                  Event.What:=evNothing;
                End;
  End;
End;

{ ==== Alerte Quitte ==== }

Constructor TQuitte.Init;
Begin
  inherited Init(51,51,254,80,'Confirmation');
  Ident:='DIA:QUITTE';
  Insert(New(PButton,Init(143,53,cmOK,    'Oui',btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(199,53,cmAnnule,'Non',btMotifEsc  ,#27,#0)));
  Insert(New(PIcone2,Init(9,31,6)));
End;

Procedure TQuitte.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+53,P.Y+26,'Etes-vous sr de vouloir');
  OutTextXY(P.X+53,P.Y+37,'Quitter SoftOptique ?');
  DrawEnd;
End;

Procedure TQuitte.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmOK     : ExitCode:=exOK;
      cmAnnule : ExitCode:=exAnnule;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

{ ==== Module : Vrification de modification ==== }

Constructor TVerif.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,342,97,'Attention !');
  Insert(New(PIcone2,Init(9,26,10)));
  Insert(New(PButton,Init(157,70,cmOui,'Oui',btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(213,70,cmNon,'Non',0,#0,#0)));
  Insert(New(PButton,Init(255,70,cmAnnule,'Annuler',btMotifEsc,#27,#0)));
End;

Procedure TVerif.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+53,P.Y+32,'Le systme optique a t modifi.');
  OutTextXY(P.X+53,P.Y+48,'Dsirez-vous le sauver sur disque ?');
  DrawEnd;
End;

Procedure TVerif.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evKeyDown : Begin
                  Case UpCase(Event.C1) Of
                    'O' : SetCommand(cmOui);
                    'N' : SetCommand(cmNon);
                  Else
                    Exit;
                  End;
                  Event.What:=evNothing;
                End;
    evCommand : Begin
                  Case Event.Command Of
                    cmOui    : ExitCode:=exOui;
                    cmNon    : ExitCode:=exNon;
                    cmAnnule : ExitCode:=exAnnule;
                  Else
                    Exit;
                  End;
                  Event.What:=evNothing;
                End;
  End;
End;

{ ==== Module : Erreur dans un accs disque ==== }

Constructor TDskErr.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,294,97,'Erreur');
  Insert(New(PIcone2,Init(9,26,11)));
  Insert(New(PButton,Init(245,70,cmOK,'OK',btMotifEnter,#13,#0)));
End;

Procedure TDskErr.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+53,P.Y+32,'Une erreur est survenue lors');
  OutTextXY(P.X+53,P.Y+48,'d''un Accs disque.');
  DrawEnd;
End;

Procedure TDskErr.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
    If Event.Command=cmOK Then
    Begin
      ExitCode:=exOK;
      Event.What:=evNothing;
    End;
End;

{ ==== Module : Calculatrice ==== }

Const
     csError  = $0001;
     csFirst  = $0002;
     csValid  = $0004;

Type PCalBut  = ^TCalBut;
     TCalBut  = Object(TAbsBut)
                  Txt : String;
                  Constructor Init(X,Y,eInfo : Integer ; eTxt : String ; eC1,eC2 : Char);
                  Procedure   Draw;                                  Virtual;
                End;

Constructor TCalBut.Init(X,Y,eInfo : Integer ; eTxt : String ; eC1,eC2 : Char);
Begin
  inherited Init(X,Y,34,18,cmCalcAction,eInfo,btUpCase,eC1,eC2);
  Ident:='CalcButton';
  Txt:=eTxt;
End;

Procedure TCalBut.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+((Size.X-Length(Txt)*8) div 2),P.Y+5,Txt);
  DrawEnd;
End;

Constructor TCalcul.Init;
Begin
  inherited Init(50,50,164,213,'Calculatrice');
  Ident:='Calculator';
  HelpCtx:='Calculatrice';
  Insert( New(PCalBut,Init(006,044,11,'MR',#0,#0)));
   Insert(New(PCalBut,Init(045,044,12,'MR+',#0,#0)));
   Insert(New(PCalBut,Init(085,044,13,'MR-',#0,#0)));
   Insert(New(PCalBut,Init(124,044,14,'MC',#0,#0)));
  Insert( New(PCalBut,Init(006,067,7,'7','7',#0)));
   Insert(New(PCalBut,Init(045,067,8,'8','8',#0)));
   Insert(New(PCalBut,Init(085,067,9,'9','9',#0)));
   Insert(New(PCalBut,Init(124,067,15,'*','*',#0)));
  Insert( New(PCalBut,Init(006,090,4,'4','4',#0)));
   Insert(New(PCalBut,Init(045,090,5,'5','5',#0)));
   Insert(New(PCalBut,Init(085,090,6,'6','6',#0)));
   Insert(New(PCalBut,Init(124,090,16,'/','/',#0)));
  Insert( New(PCalBut,Init(006,113,1,'1','1',#0)));
   Insert(New(PCalBut,Init(045,113,2,'2','2',#0)));
   Insert(New(PCalBut,Init(085,113,3,'3','3',#0)));
   Insert(New(PCalBut,Init(124,113,17,'-','-',#0)));
  Insert( New(PCalBut,Init(006,136,0,'0','0',#0)));
   Insert(New(PCalBut,Init(045,136,18,'',#241,#0)));
   Insert(New(PCalBut,Init(085,136,19,'.','.',#0)));
   Insert(New(PCalBut,Init(124,136,20,'+','+',#0)));
  Insert( New(PCalBut,Init(006,159,21,'C','C',#0)));
   Insert(New(PCalBut,Init(045,159,22,'AC','A',#0)));
   Insert(New(PCalBut,Init(085,159,23,'=','=',#0)));
   Insert(New(PButton,Init(035,189,cmOK,'OK',btMotifEnter,#13,#0)));
   Insert(New(PButton,Init(080,189,cmAnnule,'Annuler',btMotifEsc,#27,#0)));
  Clear;
End;

procedure TCalcul.CalcKey(Key : Integer);
var R: Real;
  procedure Error;
  begin
    Status := csError;
    Number := 'Error';
    Sign := ' ';
  end;
  procedure SetDisplay(R: Real);
  var S: string[17];
      P : Byte;
  begin
    If R>0 Then Sign:=' ' Else Sign:='-';
    Str(Abs(R): 0: 10, S);
    while S[Length(S)] = '0' do Dec(S[0]);
    if S[Length(S)] = '.' then Dec(S[0]);
    Number := S;
  end;
  procedure GetDisplay(var R: Real);
  var E: Integer;
  begin
    Val(Sign + Number, R, E);
  end;
  procedure CheckFirst;
  begin
    if Status = csFirst then
    begin
      Status := csValid;
      Number := '0';
      Sign := ' ';
    end;
  end;
begin
  if (Status = csError) and (Key <> 21) then Key := 100;
  case Key of
    0..9    : begin
                CheckFirst;
                if Number = '0' then Number := '';
                If Length(Number)<17 Then
                  Number := Number + Chr(Key+48);
              end;
    19     :  begin
                CheckFirst;
                if Pos('.', Number) = 0 then Number := Number + '.';
              end;
    18      : if Sign = ' ' then Sign := '-' else Sign := ' ';
    15,16,
    17,20,
    23 :      begin
                if Status = csValid then
                begin
                  Status := csFirst;
                  GetDisplay(R);
                  case Operator of
                    20 : SetDisplay(Operand + R);
                    17 : SetDisplay(Operand - R);
                    15 : SetDisplay(Operand * R);
                    16 : if R = 0 then Error else SetDisplay(Operand / R);
                  end;
                end;
                Operator := Key;
                GetDisplay(Operand);
              end;
    21:       Begin
                Status:=csFirst;
                Number:='0';
                Sign:=' ';
              End;
    22:       Clear;
    11:       Begin
                SetDisplay(Memory);
                Status:=csFirst;
              End;
    12:       Begin
                GetDisplay(R);
                Memory:=Memory+R;
                Status:=csFirst;
              End;
    13:       Begin
                GetDisplay(R);
                Memory:=Memory-R;
                Status:=csFirst;
              End;
    14:       Memory:=0;
  end;
  DrawDisplay;
end;

procedure TCalcul.Clear;
begin
  Status := csFirst;
  Number := '0';
  Sign := ' ';
  Operator := 0;
  Memory:=0;
end;

Procedure TCalcul.DrawDisplay;
Var P   : TPoint;
    S   : String[17];
    I,M : Byte;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  S:=Copy('                  ',1,17-Length(Number))+Number;
  P.X:=P.X+10;
  If Sign='-' Then
    If Memory=0 Then M:=17
                Else M:=18
              Else
    If Memory=0 Then M:=15
                Else M:=16;
  PutImage(P.X,P.Y+25,Chiffres[M]^,NormalPut);
  Inc(P.X,8);
  For I:=1 to 17 do
  Begin
    Case S[I] Of
      '0'..'9': M:=Ord(S[I])-48;
      '.'     : M:=11;
      'E'     : M:=12;
      'r'     : M:=13;
      'o'     : M:=14;
      ' '     : M:=10;
    End;
    PutImage(P.X,P.Y+25,Chiffres[M]^,NormalPut);
    Inc(P.X,8);
  End;
  DrawEnd;
End;

Procedure TCalcul.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetFillStyle(SolidFill,0);
  Bar(P.X+6,P.Y+23,P.X+157,P.Y+38);
  OutLine(P.X+6,P.Y+23,152,16,8,8,7,15);
  SetColor(8);  Line(P.X+1,P.Y+182,P.X+Size.X-2,P.Y+182);
  SetColor(15); Line(P.X+1,P.Y+183,P.X+Size.X-3,P.Y+183);
  DrawDisplay;
  DrawEnd;
End;

Procedure TCalcul.HandleEvent(Var Event : TEvent);
Var E : Integer;
    C : Char;
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evCommand :  Begin
                   Case Event.Command Of
                     cmOK         : Begin
                                      Val(Sign + Number, Transfert, E);
                                      ExitCode:=exOK;
                                    End;
                     cmAnnule     : ExitCode:=exAnnule;
                     cmCalcAction : CalcKey(Event.InfoInt);
                   Else
                     Exit;
                   End;
                   Event.What:=evNothing;
                 End;
    evKeyDown :  Case UpCase(Event.C1) Of
                   ',' : Begin
                           Event.What:=evCommand;
                           Event.Command:=cmCalcAction;
                           Event.InfoInt:=19;
                           SetEvent(Event);
                           Event.What:=evNothing;
                         End;
                   'M' : Begin
                           Repeat
                             GetEvent(Event);
                             StLine^.HandleEvent(Event);
                           Until Event.What=evKeyDown;
                           C:=UpCase(Event.C1);
                           Event.What:=evCommand;
                           Event.Command:=cmCalcAction;
                           Event.InfoInt:=0;
                           Case C Of
                             'R' : Event.InfoInt:=11;
                             '+' : Event.InfoInt:=12;
                             '-' : Event.InfoInt:=13;
                             'C' : Event.InfoInt:=14;
                           End;
                           If Event.InfoInt<>0 Then SetEvent(Event);
                           Event.What:=evNothing;
                         End;
                 End;
  End;
End;

{ ==== Module : Date et heure ==== }

Type PDatBut  = ^TDatBut;
     TDatBut  = Object(TAbsBut)
                  No : Integer;
                  Constructor Init(X,Y : Integer ; eNo : Integer);
                  Procedure   Draw;                                  Virtual;
                End;

Constructor TDatBut.Init(X,Y : Integer ; eNo : Integer);
Begin
  inherited Init(X,Y,14,13,cmDatHeurBut,eNo,0,#0,#0);
  No:=eNo;
End;

Procedure TDatBut.Draw;
Var P : TPoint;
    M : Byte;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  If No<0 Then M:=5 Else M:=6;
  PutImage(P.X+3,P.Y+3,Motifs[M]^,NormalPut);
  DrawEnd;
End;

Constructor TDatHeur.Init;
Var Temp     : Word;
    P1,P2,P3 : Word;
Begin
  inherited Init(50,50,286,193,'Date et Heure');
  Ident:='DIA:DATHEU';
  HelpCtx:='Date et heure';
  Insert(New(PDatBut,Init(9,26,-1)));
  Insert(New(PDatBut,Init(47,26,1)));
  Insert(New(PDatBut,Init(81,26,-2)));
  Insert(New(PDatBut,Init(175,26,2)));
  Insert(New(PDatBut,Init(209,26,-3)));
  Insert(New(PDatBut,Init(263,26,3)));
  Insert(New(PDatBut,Init(9,47,-4)));
  Insert(New(PDatBut,Init(47,47,4)));
  Insert(New(PDatBut,Init(81,47,-5)));
  Insert(New(PDatBut,Init(119,47,5)));
  Insert(New(PDatBut,Init(217,47,-6)));
  Insert(New(PDatBut,Init(263,47,6)));
  Insert(New(PButton,Init(157,169,cmOK,'OK',btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(202,169,cmAnnule,'Annuler',btMotifEsc,#27,#0)));
  GetDate(P1,P2,P3,Temp);
  Annee:=P1;
  Mois:=P2;
  Jour:=P3;
  Heur:=Heure;
  Min:=Minute;
  RealMin:=Min;
  GMT:=1;
End;

Procedure TDatHeur.DrawElt(N : Byte);
Var P : TPoint;
    S : String[4];
  Procedure Str0(V : Byte);
  Begin
    S[0]:=#2;
    S[1]:=Chr((V div 10)+48);
    S[2]:=Chr((V mod 10)+48);
  End;
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  SetFillStyle(SolidFill,7);
  SetColor(0);
  Case N Of
    1 : Begin
          Bar(P.X+27,P.Y+29,P.X+27+16-1,P.Y+29+8-1);
          Str0(Jour);
          OutTextXY(P.X+27,P.Y+29,S);
        End;
    2 : Begin
          Bar(P.X+99,P.Y+29,P.X+99+72-1,P.Y+29+8-1);
          OutTextXY(P.X+99+(((9-Length(NomMois[Mois]))*8) div 2),P.Y+29,
                    NomMois[Mois]);
        End;
    3 : Begin
          Bar(P.X+231,P.Y+29,P.X+231+32-1,P.Y+29+8-1);
          Str(Annee:4,S);
          OutTextXY(P.X+227,P.Y+29,S);
        End;
    4 : Begin
          Bar(P.X+27,P.Y+50,P.X+27+16-1,P.Y+50+8-1);
          Str0(Heur);
          OutTextXY(P.X+27,P.Y+50,S);
        End;
    5 : Begin
          Bar(P.X+99,P.Y+50,P.X+99+16-1,P.Y+50+8-1);
          Str0(Min);
          OutTextXY(P.X+99,P.Y+50,S);
        End;
    6 : Begin
          Bar(P.X+235,P.Y+50,P.X+235+24-1,P.Y+50+8-1);
          Str0(Abs(GMT));
          If GMT<0 Then S:='-'+S Else S:='+'+S;
          OutTextXY(P.X+235,P.Y+50,S);
          PutImage(P.X+62+WorldX[GMT-1,1],P.Y+70,World[GMT-1]^,NormalPut);
        End;
  End;
  DrawEnd;
End;

Procedure TDatHeur.Draw;
Var P : TPoint;
    I : Byte;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  OutLine(P.X+60,P.Y+68,166,86,8,0,7,15);
  PutImage(P.X+62,P.Y+70,World[12]^,NormalPut);
  SetColor(8);   Line(P.X+1,P.Y+162,P.X+285,P.Y+162);
  SetColor(15);  Line(P.X+1,P.Y+163,P.X+285,P.Y+163);
  SetColor(0);
  OutTextXY(P.X+65,P.Y+50,'h');
  OutTextXY(P.X+137,P.Y+50,'mn');
  OutTextXY(P.X+189,P.Y+50,'GMT');
  DrawEnd;
  For I:=1 to 6 do DrawElt(I);
End;

Procedure TDatHeur.HandleEvent(Var Event : TEvent);
  Function LongMois : Byte;
  Begin
    if Mois=4
    Then
      Begin
        If (Annee mod 4)=0 Then LongMois:=29
                           Else LongMois:=28;
      End
    Else
      If Mois IN [2,6,9,11]
      Then LongMois:=30
      Else LongMois:=31;
  End;
  Procedure ChangeAnnee(S : Integer);
  Begin
    Inc(Annee,S);
    If Annee<1700 Then Annee:=1700;
    If Annee>32000 Then Annee:=32000;
    DrawElt(3);
  End;
  Procedure ChangeMois(S : Integer);
  Begin
    Inc(Mois,S);
    If Mois=0  Then Begin ChangeAnnee(-1); Mois:=12; End;
    If Mois=13 Then Begin ChangeAnnee(+1); Mois:=1;  End;
    DrawElt(2);
  End;
  Procedure ChangeJour(S : Integer);
  Begin
    Inc(Jour,S);
    If Jour=0        Then Begin ChangeMois(-1); Jour:=LongMois; End;
    If Jour>LongMois Then Begin ChangeMois(+1); Jour:=1;        End;
    DrawElt(1);
  End;
  Procedure ChangeHeure(S : Integer);
  Begin
    Inc(Heur,S);
    If Heur=-1 Then Begin ChangeJour(-1); Heur:=23; End;
    If Heur=24 Then Begin ChangeJour(+1); Heur:=0;  End;
    DrawElt(4);
  End;
  Procedure ChangeMinute(S : Integer);
  Begin
    Inc(Min,S);
    If Min=-1 Then Begin ChangeHeure(-1); Min:=59; End;
    If Min=60 Then Begin ChangeHeure(+1); Min:=0;  End;
    DrawElt(5);
  End;
  Procedure ChangeGMT(S : Integer);
  Begin
    If (GMT+S>=-11) AND (GMT+S<=12) Then
    Begin
      ChangeHeure(S);
      Inc(GMT,S);
      DrawElt(6);
    End;
  End;
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evCommand :
      Begin
        Case Event.Command Of
          cmOK         :
            Begin
              While GMT<+1 do ChangeGMT(+1);
              While GMT>+1 do ChangeGMT(-1);
              SetDate(Annee,Mois,Jour);
              SetTime(Heur,Min,0,0);
              ExitCode:=exOK;
            End;
          cmAnnule     : ExitCode:=exAnnule;
          cmDatHeurBut : Case Event.InfoInt Of
                           -1 : ChangeJour(-1);
                           +1 : ChangeJour(+1);
                           -2 : ChangeMois(-1);
                           +2 : ChangeMois(+1);
                           -3 : ChangeAnnee(-1);
                           +3 : ChangeAnnee(+1);
                           -4 : ChangeHeure(-1);
                           +4 : ChangeHeure(+1);
                           -5 : ChangeMinute(-1);
                           +5 : ChangeMinute(+1);
                           -6 : ChangeGMT(-1);
                           +6 : ChangeGMT(+1);
                         End;
        Else
          Exit;
        End;
        Event.What:=evNothing;
      End;
    evTime : While Minute<>RealMin do
             Begin
               ChangeMinute(+1);
               If RealMin=59 Then RealMin:=0
                             Else Inc(RealMin);
             End;
  End;
End;

BEGIN
END.