Program ReadHelp;

Uses Crt,Disk,Drivers;

Const
     teIndex  = $0001;

Type PPage    = ^TPage;
     PEntree  = ^TEntree;
     TEntree  = Record
                  Suivant : PEntree;
                  Texte   : String;
                  Tpe     : Word;
                End;
     TPage    = Record
                  Liste   : PEntree;
                  Suivant : PPage;
                  Titre   : String;
                End;

Var Help : PPage;

Procedure AffPage(P : PPage);
Var E : PEntree;
Begin
  ClrScr;
  TextAttr:=$1F;ClrEol;Writeln(P^.Titre);
  TextAttr:=$07;Writeln;
  E:=P^.Liste;
  While E<>NIL do
  Begin
    If (E^.Tpe AND teIndex)<>0 Then Begin TextAttr:=$1F; Write('<'); End;
    Write(E^.Texte);
    If (E^.Tpe AND teIndex)<>0 Then Begin Write('>'); TextAttr:=$07; End;
    E:=E^.Suivant;
  End;
  Readln;
End;

Procedure AffIndex;
Var P : PPage;
    C : Boolean;
    Y : Byte;
Begin
  ClrScr;
  P:=Help;
  C:=FALSE;Y:=1;
  While (P<>NIL) do
  Begin
    If C Then GotoXY(40,Y) Else GotoXy(1,Y);
    Write(P^.Titre);
    Inc(Y);
    P:=P^.Suivant;
  End;
  Readln;
End;

Procedure HelpInit;
Var F : TDisk;
    P : PPage;
  Procedure LitPage;
  Var C    : Char;
      E,E1 : PEntree;
  Begin
    P:=NIL;
    F.Read(C,1);
    If C<>'#' Then Exit;
    P:=New(PPage);
    P^.Titre:='';
    P^.Liste:=NIL;
    P^.Suivant:=NIL;
    F.Read(C,1);
    While Not (C IN [#13,#10]) do
    Begin
      P^.Titre:=P^.Titre+C;
      F.Read(C,1);
    End;
    While C IN [#13,#10] do F.Read(C,1);
    While Not (C IN ['#','*']) do
    Begin   { Lit un Element }
      E:=New(PEntree);
      E^.Texte:='';
      E^.Tpe:=0;
      E^.Suivant:=NIL;
      If C='$'
      Then
        Begin
          E^.Tpe:=E^.Tpe OR teIndex;
          F.Read(C,1);
          While C<>'$' do
          Begin
            E^.Texte:=E^.Texte+C;
            F.Read(C,1);
          End;
          F.Read(C,1);     { Se place au dbut du suivant }
        End
      Else
        Begin
          While Not (C IN [#10,#13,'$']) do
          Begin
            If C='\' Then
            Begin
              F.Read(C,1);
              While C IN [#13,#10] do F.Read(C,1);
            End;
            E^.Texte:=E^.Texte+C;
            F.Read(C,1);
          End;
          While C IN [#10,#13] do
          Begin
            E^.Texte:=E^.Texte+C;
            F.Read(C,1);
          End;
        End;
      { Ajoute le nouvel lment en fin de liste }
      If P^.Liste=NIL
      Then P^.Liste:=E
      Else
        Begin
          E1:=P^.Liste;
          While (E1^.Suivant<>NIL) do
            E1:=E1^.Suivant;
          E1^.Suivant:=E;
        End;
    End;
    F.Seek(-1,stCourant);  { Se positionne sur le '#' }
  End;
Begin
  F.Init('Optique.HLP',stOpen);
  Repeat
    LitPage;
    If P<>NIL Then
    Begin
      AffPage(P);
      P^.Suivant:=Help;
      Help:=P;
    End;
  Until P=NIL;
  F.Done;
End;

Procedure HelpDone;
Var P,P1 : PPage;
    E,E1 : PEntree;
Begin
  P:=Help;
  While P<>NIL do
  Begin
    P1:=P^.Suivant;
    E:=P^.Liste;
    While E<>NIL do
    Begin
      E1:=E^.Suivant;
      Dispose(E);
      E:=E1;
    End;
    Dispose(P);
    P:=P1;
  End;
End;

Procedure HelpSearch(Clef : String ; Var Found : PPage);
Var P : PPage;
Begin
  P:=Help;
  Found:=NIL;
  Clef:=UpStr(Clef);
  While (P<>NIL) do
  Begin
    If UpStr(P^.Titre)=Clef Then Begin Found:=P; Exit; End;
    P:=P^.Suivant;
  End;
End;

Var Taille : LongInt;

BEGIN
  Taille:=MemAvail;
  HelpInit;
  AffIndex;
  HelpDone;
  ClrScr;
  Writeln('Taille de mmoire non libre : ',MemAvail-Taille);
END.