{**********************************************************}
{                                                          }
{                   Projet SoftOptique                     }
{                   Corps du programme                     }
{                                                          }
{   Debut du projet : 10.04.93                             }
{   Mise A Jour     : 01.06.93                   cm0=400   }
{                                                          }
{**********************************************************}

Program Optique;

{$V-}

Uses Graph,        { Unit standard du Turbo Pascal pour les graphiques      }
     Crt,          { Unit standard du Turbo Pascal pour l'accs console     }
     Dos,          { Unit standard du Turbo Pascal pour l'accs au DOS      }
     Disk,         { Gestion des fichiers dans le style DosStream            }
     Drivers,      { Gestion : cran, calvier, souris, disque, configuration }
     ObjetAbs,     { Objets abstraits TObjet, TGroup                         }
     Objet,        { Objets utiles : TDialog, TButton, TCoche, TEdit..       }
     Outils,       { Outils : TStLine, TBrowser, TConfig                     }
     Elements,     { Elements optiques TElement, TLentill, TMiroir, TDiaph.. }
     Help;         { Aide contextuelle                                       }

Const
  { Constantes des commandes }
     cmOptique    = 400;
     cmZoomInfo   = cmOptique+01;
     cmZoomMoins  = cmOptique+02;
     cmPoubelle   = cmOptique+03;
     cmPoubInfo   = cmOptique+04;
     cmSuppr      = cmOptique+05;
     cmObjetDef   = cmOptique+06;
     cmImage      = cmOptique+07;
     cmFichier    = cmOptique+08;
     cmFusion     = cmOptique+09;
     cmAbout      = cmOptique+10;
     cmTools      = cmOptique+11;
     cmBougie     = cmOptique+12;
     cmCaracteric = cmOptique+13;

Type PApp     = ^TApp;
     PWrkZone = ^TWrkZone;
     TApp     = Object(TGroup)
                  EventStock : TEvent;
                  Constructor Init;
                  Destructor  Done;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   GetEvent(Var Event : TEvent);          Virtual;
                  Procedure   SetEvent(Event : TEvent);              Virtual;
                  Procedure   ZoomInfo;
                  Procedure   ZoomMoins;
                  Procedure   Poubelle;
                  Procedure   PoubInfo;
                  Procedure   ObjetDef;
                  Procedure   Quit;
                  Procedure   Nouveau;
                  Function    VerifieModif : Boolean;
                  Procedure   MenuTools;
                  Procedure   MenuFichier;
                  Procedure   MenuBougie;
                  Procedure   DoCharge(Fusion : Boolean ; N : String);
                  Procedure   Charge(Fusion : Boolean);
                  Function    Sauve(AskName : Boolean) : Boolean;
                End;
     TWrkZone = Object(TGroup)
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   RayTrace(Xp,Yp : Real ; HB,BL : Boolean ;
                                       Var R : TRay);
                End;

Var App    : TApp;
    Pupil  : PPupil;
    Bougie : PBougie;
    ImageB : TBougie;
    ImageR : TBougie;

{$I Stable.Inc}

{ ==== Module : Zone de travail ==== }

Constructor TWrkZone.Init;
Begin
  inherited Init(4,4,GetMaxX-33,GetMaxY-28,0);
  Ident:='WORKZONE';
  HelpCtx:='Zone de travail';
  MouseAspect:=MouseCroix;
  Bougie:=New(PBougie,Init(-950,0,0,2));
  Insert(Bougie);
  Pupil:=New(PPupil,Init(-800,50));
  Insert(Pupil);
End;

Var Diaph : Boolean;

Procedure TWrkZone.RayTrace(Xp,Yp : Real ; HB,BL : Boolean ; Var R : TRay);
Var R1,R2 : TRay;
    EC    : PElement;
  Procedure Trace;
  Var X1,Y1,X2,Y2,T,N : Real;
      eX1,eY1,eX2,eY2 : Integer;
      X,Y,L,H         : Real;
    Procedure TraceFleche(X,Y : Integer);
    Begin
      If Sens Then Begin
                     Line(X,Y,Trunc(X-H-L),Trunc(Y+L-H));
                     Line(X,Y,Trunc(X+H-L),Trunc(Y-L-H));
                   End
              Else Begin
                     Line(X,Y,Trunc(X-H+L),Trunc(Y+L+H));
                     Line(X,Y,Trunc(X+H+L),Trunc(Y-L+H));
                   End;
    End;
  Begin
    X1:=R1.X; X2:=R2.X;                { Copie les coordonnes pour travail  }
    Y1:=R1.Y; Y2:=R2.Y;
    If X1>X2 Then                      { Range les deux points dans l'ordre  }
    Begin                              { de leurs abscisses                  }
      T:=Y1;  Y1:=Y2;  Y2:=T;
      T:=X1;  X1:=X2;  X2:=T;
    End;
    If X2<Zooms^.X1 Then Exit;         { Vrifie que c'est bien dans la      }
    If X1>Zooms^.X2 Then Exit;         { Partie visible en X                 }
    If (X1<Zooms^.X1) Then             { Ramne le trait  la partie visible }
    Begin                              { A gauche...                         }
      Y1:=(Zooms^.X1-X1)/(X2-X1)*(Y2-Y1)+Y1;
      X1:=Zooms^.X1;
    End;
    If (X2>Zooms^.X2) Then             { A droite.                           }
    Begin
      Y2:=(Zooms^.X2-X1)/(X2-X1)*(Y2-Y1)+Y1;
      X2:=Zooms^.X2;
    End;
    If MinReal(Y1,Y2)>Zooms^.Y1 Then Exit;  { Vrifie que c'est dans la      }
    If MaxReal(Y1,Y2)<Zooms^.Y2 Then Exit;  { Partie visible en Y            }
    If (Y1>Zooms^.Y1) Then                  { Coupe  la partie visible      }
    Begin                                   { En haut...                     }
      X1:=(Zooms^.Y1-Y1)/(Y2-Y1)*(X2-X1)+X1;
      Y1:=Zooms^.Y1;
    End;
    If (Y2>Zooms^.Y1) Then
    Begin
      X2:=(Zooms^.Y1-Y1)/(Y2-Y1)*(X2-X1)+X1;
      Y2:=Zooms^.Y1;
    End;
    If (Y1<Zooms^.Y2) Then                  { En bas.                        }
    Begin
      X1:=(Zooms^.Y2-Y1)/(Y2-Y1)*(X2-X1)+X1;
      Y1:=Zooms^.Y2;
    End;
    If (Y2<Zooms^.Y2) Then
    Begin
      X2:=(Zooms^.Y2-Y1)/(Y2-Y1)*(X2-X1)+X1;
      Y2:=Zooms^.Y2;
    End;
    eX1:=EX(X1);
    eX2:=EX(X2);
    eY1:=EY(Y1);
    eY2:=EY(Y2);
    Line(eX1,eY1,eX2,eY2);
    X:=(eX1+eX2)/2;
    Y:=(eY1+eY2)/2;
    L:=eX2-eX1;
    H:=eY2-eY1;
    N:=Sqrt(Sqr(L)+Sqr(H));
    If N=0 Then Exit;                     { Pas de longueur -> rien  tracer }
    L:=L/N*4;
    H:=H/N*4;
    If HB Then TraceFleche(Trunc(X),Trunc(Y))
          Else Begin
                 TraceFleche(Trunc(X+L/2),Trunc(Y+H/2));
                 TraceFleche(Trunc(X-L/2),Trunc(Y-H/2));
               End;
  End;
  Function Prochain : PElement;
  Var E,R   : PObjet;
      DX,RX : Real;
  Begin
    If Not Sens Then E:=Pupil^.Suiv
                Else E:=Pupil;
    R:=NIL;
    RX:=200000;
    While (E<>NIL) do
    Begin
      If (E^.Etat AND stTraite)=0 Then
      Begin
        DX:=PElement(E)^.PosX-R1.X;
        If Not Sens Then DX:=-DX;
        If (DX>=0) Then
          If DX<RX Then
          Begin
            RX:=DX;
            R:=E;
          End;
      End;
      E:=E^.Suiv;
    End;
    Prochain:=PElement(R);
  End;
Begin
  Sens:=TRUE;
  Diap:=FALSE;
  Case Bougie^.Tpe Of
    1 : Begin                                    { Objet  distance finie    }
          R1.X:=Bougie^.PosX;
          R1.Y:=Bougie^.Diam;
          R1.A:=(Yp-R1.Y)/(Xp-R1.X);
        End;
    2 : Begin                                    { Objet  l'infini          }
          R1.X:=-100000;
          R1.A:=Bougie^.Angle;
          R1.Y:=Yp-(Xp-R1.X)*R1.A;
        End;
  End;
  EC:=Pupil;
  While(EC<>NIL) do
  Begin
    EC^.Etat:=EC^.Etat AND (Not stTraite);
    EC:=PElement(EC^.Suiv);
  End;
  EC:=Prochain;
  While (EC<>NIL) AND (Not Diap) do
  Begin
    R2.X:=EC^.PosX;
    R2.A:=R1.A;
    R2.Y:=R1.Y+(R2.X-R1.X)*R1.A;
    Trace;
    EC^.Conjugue(R2,BL);
    R1:=R2;
    EC^.Etat:=EC^.Etat OR stTraite;
    EC:=Prochain;
  End;
  If Diap Then Begin Diaph:=TRUE; Exit; End;
  If Sens
  Then
    Begin
      If R1.X>Zooms^.X2 Then Exit;
      R2.X:=Zooms^.X2;
      R2.A:=R1.A;
      R2.Y:=R1.Y+(R2.X-R1.X)*R1.A;
      Trace;
    End
  Else
    Begin
      If R1.X<Zooms^.X1 Then Exit;
      R2.X:=Zooms^.X1;
      R2.A:=R1.A;
      R2.Y:=R1.Y+(R2.X-R1.X)*R1.A;
      Trace;
    End;
  R:=R1;
End;

Procedure TWrkZone.Draw;
Var P     : TPoint;
    E     : PObjet;
    F1,F2 : TRay;
Begin
  DrawBegin;
  { Trace les lments optiques }
  inherited Draw;
  MakeGlobal(Origin,P);
  { Calcule et trace la marche des rayons lumineux bleus }
  SetColor(9);
  Diaph:=FALSE;
  RayTrace(Pupil^.PosX,+Pupil^.Diam/2,TRUE,TRUE,F1);
  RayTrace(Pupil^.PosX,-Pupil^.Diam/2,FALSE,TRUE,F2);
  If Diaph Then ImageB.Tpe:=3
           Else
    If Abs(F1.A-F2.A)<4.84E-6            { On nglige la seconde d'arc }
    Then    { Image  l'infini }
      Begin
        ImageB.Tpe:=2;
        ImageB.Angle:=F1.A;
      End
    Else    { Image  distance finie : intersection de F1 et F2 }
      Begin
        ImageB.Tpe:=1;
        ImageB.PosX:=(F2.Y-F1.Y+F1.A*F1.X-F2.A*F2.X)/(F1.A-F2.A);
        ImageB.Diam:=(F1.Y+F1.A*(ImageB.PosX-F1.X));
      End;
  { Calcule et trace la marche des rayons lumineux rouges }
  SetColor(12);
  Diaph:=FALSE;
  RayTrace(Pupil^.PosX,+Pupil^.Diam/2,TRUE,FALSE,F1);
  RayTrace(Pupil^.PosX,-Pupil^.Diam/2,FALSE,FALSE,F2);
  If Diaph Then ImageR.Tpe:=3
           Else
    If F1.A=F2.A
    Then    { Image  l'infini }
      Begin
        ImageR.Tpe:=2;
        ImageR.Angle:=F1.A;
      End
    Else    { Image  distance finie : intersection de F1 et F2 }
      Begin
        ImageR.Tpe:=1;
        ImageR.PosX:=(F2.Y-F1.Y+F1.A*F1.X-F2.A*F2.X)/(F1.A-F2.A);
        ImageR.Diam:=(F1.Y+F1.A*(ImageR.PosX-F1.X));
      End;
  { Trace l'axe et l'entourage de la zone de travail }
  SetColor(8);
  Line(P.X,EY(0),P.X+Size.X-1,EY(0));
  SetColor(3);
  Rectangle(P.X-1,P.Y-1,P.X+Size.X,P.Y+Size.Y);
  { Trace les pointills de slection }
  E:=Liste;
  While E<>NIL do
  Begin
    If (E^.Etat AND stSelected)<>0 Then PElement(E)^.DrawSelect;
    E:=E^.Suiv;
  End;
  DrawEnd;
End;

Procedure TWrkZone.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evMouseLDown : If MouseInObjet Then
                   Begin
                     Outil^.WrkZoneClic(Event.Where);
                     Event.What:=evNothing;
                   End;
  End;
End;

{ ==== Module : TApplication ==== }

{ --- Objet/Image --- }

Procedure TApp.MenuBougie;
Var Menu1 : PMenu;
Begin
  Menu1:=New(PMenu,Init(0,151+8,'Objet/Image'));
  Menu1^.Insert(New(PMenuId,Init('Objet...   ','',#0,#0,cmObjetDef)));
  Menu1^.Insert(New(PMenuId,Init('Image...   ','',#0,#0,cmImage)));
  Menu1^.Prepare;
  Menu1^.Origin.X:=620-Menu1^.Size.X;
  Menu1^.HelpCtx:='Menu objet/image';
  ExecObjet(Menu1);
End;

Type PImage   = ^TImage;
     TImage   = Object(TDialog)
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;

Constructor TImage.Init;
Begin
  inherited Init(50,50,394,141,'Calcul de l''Image');
  Insert(New(PButton,Init(345,114,cmOK,'OK',btMotifEnter,#13,#0)));
End;

Procedure TImage.Draw;
Var P : TPoint;
    S,S1 : String;
    V    : Byte;
  Procedure AffData(I : PBougie ; Y : Integer);
  Begin
    Case I^.Tpe Of
      1 : Begin
            OutTextXY(P.X+9,Y,'Le point image est  distance finie');
            Str(I^.PosX:0:4,S1);
            V:=Pos('.',S1); S1[V]:=',';
            S:='Il se situe en X='+S1+' ; Y=';
            Str(I^.Diam:0:4,S1);
            V:=Pos('.',S1); S1[V]:=',';
            S:=S+S1+'.';
            OutTextXY(P.X+9,Y+13,S);
          End;
      2 : Begin
            OutTextXY(P.X+9,Y,'Le point image est  l''infini');
            Str((I^.Angle*180/PI):0:4,S1);
            OutTextXY(P.X+9,Y+13,'Il est vu  l''infini sous un angle de '+S1+'');
          End;
      3 : Begin
            OutTextXY(P.X+9,Y,'Il n''y a pas d''image :');
            OutTextXY(P.X+9,Y+13,'Les rayons sont diaphragms');
          End;
    End;
  End;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+6,P.Y+26,'Image pour les rayons Rouges : ');
  AffData(@ImageR,P.Y+39);
  OutTextXY(P.X+6,P.Y+72,'Image pour les rayons Bleus : ');
  AffData(@ImageB,P.Y+85);
  SetColor(8);  Line(P.X+1,P.Y+65,P.X+393,P.Y+65);
  SetColor(15); Line(P.X+1,P.Y+66,P.X+393,P.Y+66);
  DrawEnd;
End;

Procedure TImage.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
    If Event.Command=cmOK Then
    Begin
      ExitCode:=exOK;
      Event.What:=evNothing;
    End;
End;

{ --- Outils --- }

Procedure TApp.MenuTools;
Var Menu1 : PMenu;
Begin
  Menu1:=New(PMenu,Init(0,201+16,'Outils'));
  Menu1^.Insert(New(PMenuId,Init('Configuration...','',#0,#0,cmConfig)));
  Menu1^.Insert(New(PMenuId,Init('Calculatrice...','',#0,#0,cmCalculator)));
  Menu1^.Insert(New(PMenuId,Init('Date et heure...','',#0,#0,cmDateHeure)));
  Menu1^.Insert(New(PMenuId,Init('A propos de...','',#0,#0,cmAbout)));
  Menu1^.Prepare;
  Menu1^.Origin.X:=620-Menu1^.Size.X;
  Menu1^.HelpCtx:='Menu outils';
  ExecObjet(Menu1);
End;

Type PAbout   = ^TAbout;
     TAbout   = Object(TDialog)
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;

Constructor TAbout.Init;
Begin
  inherited Init((GetMaxX-234) div 2,(GetMaxY-136) div 2,234,136,'A propos de...');
  Ident:='A Propos...';
  Insert(New(PButton,Init(186,109,cmOK,'OK',btMotifEnter,#13,#0)));
End;

Procedure TAbout.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  PutImage(P.X+16,P.Y+34,Motifs[4]^,NormalPut);
  SetColor(0);
  OutTextXY(P.X+37,P.Y+85,'V1.0  Avril-Mai 1993');
  DrawEnd;
End;

Procedure TAbout.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  Case Event.What of
    evCommand : If Event.Command=cmOK Then
                Begin
                  Event.What:=evNothing;
                  ExitCode:=exOK;
                End;
    evKeyDown : If (Event.C1=#27) AND (Event.C2=#0) Then
                Begin
                  SetCommand(cmOK);
                  Event.What:=evNothing;
                End;
  End;
End;

{ --- Gestion des fichiers --- }

Function TApp.VerifieModif : Boolean;
Begin
  If Modif
  Then
    Case ExecObjet(New(PVerif,Init(50,50))) Of
      exOui    : VerifieModif:=Sauve(FALSE);
      exNon    : VerifieModif:=TRUE;
      exAnnule : VerifieModif:=FALSE;
    End
  Else VerifieModif:=TRUE;
End;

Procedure TApp.MenuFichier;
Var Menu1 : PMenu;
Begin
  Menu1:=New(PMenu,Init(0,176+16,'Fichier'));
  Menu1^.Insert(New(PMenuId,Init('Nouveau','',#0,#0,cmNew)));
  Menu1^.Insert(New(PMenuId,Init('Charger...','F3',#0,#61,cmOpen)));
  Menu1^.Insert(New(PMenuId,Init('Fusionner...','',#0,#0,cmFusion)));
  Menu1^.Insert(New(PMenuId,Init('Sauver','F2',#0,#60,cmSave)));
  Menu1^.Insert(New(PMenuId,Init('Sauver comme...','',#0,#0,cmSaveAs)));
  Menu1^.Prepare;
  Menu1^.Origin.X:=620-Menu1^.Size.X;
  Menu1^.HelpCtx:='Menu fichier';
  ExecObjet(Menu1);
End;

{ --- Sauvegarde ---}

Function TApp.Sauve(AskName : Boolean) : Boolean;
Var D : PDialog;
    R : BrowsRec;
    F : Boolean;
    P : TDisk;
    O : PObjet;
    S : String;
Begin
  F:=TRUE;
  If (NomFichier='') OR AskName Then
  Begin
    D:=New(PBrowser,Init('Sauvegarde sur disque',4));
    Insert(D);
    Case D^.Exec Of
      exOK     : Begin
                   D^.GetData(R);
                   NomFichier:=R.Chemin+R.Fichier;
                   If Pos('.',NomFichier)=0 Then NomFichier:=NomFichier+'.OPT';
                 End;
      exAnnule : F:=FALSE;
    End;
    Dispose(D,Done);
  End;
  If F Then
  Begin
    P.Init(NomFichier,stCreate);
    If P.Error=0 Then
    Begin
      S:='Fichier SoftOptique V1.0'+#13#10#26;
      P.Write(S[1],27);
      { Ecrit tous les lments de la zone de travail }
      O:=WrkZone^.Liste;
      While O<>NIL do
      Begin
        PElement(O)^.Write(@P);
        O:=O^.Suiv;
      End;
      { Ecrit les donnes du zoom }
      S:='Zoom      :';
      P.Write(S[1],11);
      P.Write(Zooms^,SizeOf(TZoom));
      P.Done;
    End;
    F:=(P.Error=0);
    If Not F Then
    Begin
      ExecObjet(New(PDskErr,Init(50,50)));
      NomFichier:='';
    End;
  End;
  If F Then
  Begin
    Modif:=FALSE;
    DoneDskItems;     { Car la structure des rpertoires a t modifie }
  End;
  Sauve:=F;
  SetCommand(cmNomFichier);
End;

{ --- Nouveau --- }

Procedure TApp.Nouveau;
Begin
  If VerifieModif Then
  Begin
    While WrkZone^.Liste<>NIL do
      Dispose(WrkZone^.Liste,Done);
    Bougie:=New(PBougie,Init(-950,0,0,2));
    WrkZone^.Insert(Bougie);
    Pupil:=New(PPupil,Init(-800,50));
    WrkZone^.Insert(Pupil);
    WrkZone^.Draw;
    Modif:=FALSE;
    NomFichier:='';
    SetCommand(cmNomFichier);
  End;
End;

{ --- Chargement --- }

Procedure TApp.DoCharge(Fusion : Boolean ; N : String);
Var F : TDisk;
    E : PElement;
    S : String;
    Z : TZoom;
Begin
  If Pos('.',N)=0 Then N:=N+'.OPT';
  F.Init(N,stOpen);
  If F.Error=0 Then
  Begin
    F.Read(S[1],27);
    S[0]:=#27;
    If S='Fichier SoftOptique V1.0'+#13#10#26 Then
    Begin
    { Si ce n'est pas une fusion, on supprime avant l'ancien systme }
    { Et on garde le nom de fichier                                  }
      If (Not Fusion) Then
      Begin
        While WrkZone^.Liste<>NIL do
          Dispose(WrkZone^.Liste,Done);
        NomFichier:=N;
      End;
      Modif:=Fusion;
      S[0]:=#11;
      F.Read(S[1],11);
      While (F.Error=0) do
      Begin
        If S='Bougie    :' Then
        Begin
          E:=New(PBougie,Init(0,0,0,0));
          E^.Read(@F);
          If (Not Fusion) Then Begin
                                 Bougie:=PBougie(E);
                                 WrkZone^.Insert(E)
                               End
                          Else Dispose(E,Done);
        End;
        If S='Pupille   :' Then
        Begin
          E:=New(PPupil,Init(0,0));
          E^.Read(@F);
          If (Not Fusion) Then Begin
                                 Pupil:=PPupil(E);
                                 WrkZone^.Insert(E)
                               End
                          Else Dispose(E,Done);
        End;
        If S='Lentille  :' Then
        Begin
          E:=New(PLentill,Init(0,0,0,0,0,FALSE));
          E^.Read(@F);
          WrkZone^.Insert(E);
        End;
        If S='Diaphragme:' Then
        Begin
          E:=New(PDiaph,Init(0,0,0));
          E^.Read(@F);
          WrkZone^.Insert(E);
        End;
        If S='Miroir    :' Then
        Begin
          E:=New(PMiroir,Init(0,0,0,0,FALSE));
          E^.Read(@F);
          WrkZone^.Insert(E);
        End;
        If S='Zoom      :' Then
        Begin
          F.Read(Z,SizeOf(TZoom));
          If (Not Fusion) Then Zoom(Z.X1,Z.Y1,Z.X2,Z.Y2,Z.Pas,Z.Gril);
        End;
        F.Read(S[1],11);
      End;
    End;
    F.Done;
  End;
End;

Procedure TApp.Charge(Fusion : Boolean);
Var B : PBrowser;
    R : BrowsRec;
    N : String;
Begin
  If (Not VerifieModif) Then Exit;
  B:=New(PBrowser,Init('Chargement depuis le disque',5));
  Insert(B);
  If B^.Exec=exOK Then
  Begin
    B^.GetData(R);
    N:=R.Chemin+R.Fichier;
    DoCharge(Fusion,N);
    WrkZone^.Draw;
  End;
  Dispose(B,Done);
  SetCommand(cmNomFichier);
End;

{ --- Initialisation, Final, et Interception vnements --- }

Constructor TApp.Init;
Var I : Byte;
    A : PAction;
Begin
  DriversInit;
  Write('Aide contextuelle... ');
  HelpInit;
  Writeln('OK');
  Write('Application......... ');
  inherited Init(0,0,GetMaxX+1,GetMaxY+1,1);
  Ident:='APP';
  { Initialise la barre d'tat }
  StLine:=New(PStLine,Init(0,GetMaxY-20,GetMaxX+1,21));
  Insert(StLine);
  { Initialise la barre d'icones }
  Insert(New(PZomPlus,Init(GetMaxX-25,1)));
  A:=New(PAction,Init(GetMaxX-25,26,icZoomMoins,cmZoomMoins,cmInterdite,
                 #0,#97,'Retour au zoom prcdent','Alt-F4'));
  A^.HelpCtx:='Zoom Arrire';
  Insert(A);
  Outil:=New(PSelect,Init(GetMaxX-25, 51));
  Outil^.Etat:=stSelected;
  Insert(Outil);
  Insert(New(PLenPlus,Init(GetMaxX-25,76+8)));
  Insert(New(PMirPlus,Init(GetMaxX-25,101+8)));
  Insert(New(PDiaPlus,Init(GetMaxX-25,126+8)));
  IcPoub:=New(PAction,Init(GetMaxX-25,151+8,icPoubVide,cmPoubelle,cmPoubInfo+cmInterdite,
                 #0,#83,'Suppression d''un lment','Suppr'));
  IcPoub^.HelpCtx:='Supprimer';
  Insert(IcPoub);
  Insert(New(PAction,Init(GetMaxX-25,176+8,icObjet,cmBougie,cmInterdite,
                 #0,#24,'Accs au menu "Objet/Image"','Alt-O')));
  Insert(New(PAction,Init(GetMaxX-25,201+16,icDisk,cmFichier,cmInterdite,
                 #0,#33,'Accs au menu "Fichier"','Alt-F')));
  Insert(New(PAction,Init(GetMaxX-25,226+16,icConfig,cmTools,cmInterdite,
                 #0,#0,'Accs au menu "Outils"','')));
  A:=New(PAction,Init(GetMaxX-25,276+16,icQuit,cmQuit,cmInterdite,
                #0,#45,'Quitte SoftOptique','Alt-X'));
  A^.HelpCtx:='Quitter';
  Insert(A);
  { Initialise les raccourcis claviers du menu "Fichier" }
  Insert(New(PHotKey,Init(#0,#60,cmSave)));
  Insert(New(PHotKey,Init(#0,#61,cmOpen)));
  { Initialise la zone de travail }
  WrkZone:=New(PWrkZone,Init);
  Insert(WrkZone);
  { Fentre "A propos..." comme page de prsentation }
  If NoPre Then EventStock.What:=evNothing
           Else Begin
                  EventStock.What:=evCommand;
                  EventStock.Command:=cmAbout;
                End;
  NomFichier:='';
  Application:=@Self;
  For I:=1 to 10 do
    Poubel[I]:=NIL;
  Modif:=FALSE;
  If ACharger<>'' Then DoCharge(FALSE,ACharger);
  Writeln('OK');
End;

Destructor TApp.Done;
Var I : Byte;
Begin
  For I:=1 to 10 do
    If Poubel[I]<>NIL Then Dispose(Poubel[I],Done);
  DriversDone;
  HelpDone;
  inherited Done;
End;

Procedure TApp.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmZoomInfo   : ZoomInfo;
      cmZoomMoins  : ZoomMoins;
      cmLentilInfo : LentilInfo;
      cmDiaphInfo  : DiaphInfo;
      cmMiroirInfo : MiroirInfo;
      cmPoubelle   : Poubelle;
      cmPoubInfo   : PoubInfo;
      cmFichier    : MenuFichier;
      cmTools      : MenuTools;
      cmConfig     : ExecObjet(New(PConfig,Init));
      cmQuit       : Quit;
      cmSave       : Sauve(FALSE);
      cmSaveAs     : Sauve(TRUE);
      cmNew        : Nouveau;
      cmOpen       : Charge(FALSE);
      cmFusion     : Charge(TRUE);
      cmObjetDef   : ObjetDef;
      cmAbout      : ExecObjet(New(PAbout,Init));
      cmCalculator : ExecObjet(New(PCalcul,Init));
      cmDateHeure  : ExecObjet(New(PDatHeur,Init));
      cmBougie     : MenuBougie;
      cmImage      : ExecObjet(New(PImage,Init));
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

{ ==== Prog Principal ==== }

Var MemDispo : LongInt;

BEGIN
  MemDispo:=MemAvail;
  LigneCommande;
  App.Init;
  App.Exec;
  App.Done;
  If MemDispo<>MemAvail Then
  Begin
    Writeln('Info programmeur');
    Writeln('----------------');
    Writeln('Attention : il reste ',MemDispo-MemAvail,' octets de mmoire');
    Writeln('            non libre !');
    Writeln;
    Writeln;
  End;
END.