{ Soft-Optique : parties de programmes stabilises }
{ Mise  jour  : 25.04.93                          }

{ =========================== }
{   Outil abstrait TZoneDef   }
{ =========================== }

Type PZoneDef = ^TZoneDef;
     TZoneDef = Object(TOutil)
                  Procedure   WrkZoneClic(P : TPoint);               Virtual;
                  Procedure   WrkZoneDef(P1,P2 : TPoint);            Virtual;
                End;

Procedure TZoneDef.WrkZoneClic(P : TPoint);
Var Event  : TEvent;
    P2     : TPoint;
    ZL     : Byte;
    T,S,MS : Word;
Begin
  MouseHide;
  MouseLimits(4,4,GetMaxX-30,GetMaxY-25);
  SetWriteMode(XORPut);
  SetColor(15);
  ZL:=1; SetLineStyle(UserBitLn,ZoneDefLn[ZL],1);
  P2:=P;
  GetTime(T,T,T,S);
  MS:=S;
  Rectangle(P.X,P.Y,P2.X,P2.Y);
  Repeat
    GetMouseEvent(Event);
    StLine^.HandleEvent(Event);
    SetColor(15);
    If Event.What=evMouseMove Then
    Begin
      Rectangle(P.X,P.Y,P2.X,P2.Y);
      P2:=Event.Where;
      Rectangle(P.X,P.Y,P2.X,P2.Y);
    End;
    GetTime(T,T,T,S);
    If (S-MS>1) Then
    Begin
      MS:=S;
      Inc(ZL);
      If ZL=5 Then ZL:=1;
      Rectangle(P.X,P.Y,P2.X,P2.Y);
      SetLineStyle(UserBitLn,ZoneDefLn[ZL],1);
      Rectangle(P.X,P.Y,P2.X,P2.Y);
    End;
  Until Event.What=evMouseLUp;
  Rectangle(P.X,P.Y,P2.X,P2.Y);
  SetLineStyle(SolidLn,0,1);
  SetWriteMode(NormalPut);
  MouseLimits(0,0,GetMaxX,GetMaxY);
  MouseShow;
  WrkZoneDef(P,P2);
End;

Procedure TZoneDef.WrkZoneDef(P1,P2 : TPoint);
Begin
End;

{ ======================= }
{          ZOOM           }
{ ======================= }

{ ---- Outil : TZomPlus ---- }

Type PZomPlus = ^TZomPlus;
     TZomPlus = Object(TZoneDef)
                  Constructor Init(X,Y : Integer);
                  Procedure   WrkZoneDef(P1,P2 : TPoint);            Virtual;
                End;

Constructor TZomPlus.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,icZoomPlus,cmZoomInfo,#0,#62,'Choix d''un nouveau zoom','F4');
  OutilAspect:=MouseZoom;
  HelpCtx:='Zoom Avant (Outil)';
End;

Procedure TZomPlus.WrkZoneDef(P1,P2 : TPoint);
Var Y1,Y2 : Real;
Begin
  If Abs(P1.X-P2.X)>5 Then
  Begin
    Y1:=Abs(RY(P1.Y));
    Y2:=Abs(RY(P2.Y));
    If Y2>Y1 Then Y1:=Y2;
    Zoom(RX(P1.X),Y1,RX(P2.X),-Y1,0,FALSE);
    WrkZone^.Draw;
    Modif:=TRUE;
    SetCommand(cmModif);
  End;
End;

{ ---- Dialogue : TZomInfo ---- }

Type PZomInfo = ^TZomInfo;
     TZomInfo = Object(TDialog)
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     TZoomRec = Record
                  XMin,XMax : Real;
                  YMax      : Real;
                  Pas       : Real;
                  Gril      : Boolean;
                End;

Constructor TZomInfo.Init;
Var E : PEdit;
Begin
  inherited Init(50,50,254,143,'Paramtres du Zoom');
  Ident:='DIA:ZOOM';
  HelpCtx:='Zoom Avant (Dialogue)';
  Insert(New(PButton,Init(111,116,cmOK,   'OK',      btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(167,116,cmAnnule,'Annuler',btMotifEsc,  #27,#0)));
  Insert(New(PIcone2,Init(9,37,8)));
  E:=New(PReEdit,Init(117,26,15));
  Insert(E);
  Insert(New(PReEdit,Init(117,47,15)));
  Insert(New(PReEdit,Init(117,68,15)));
  Insert(New(PReEdit,Init(187,92,6)));
  Insert(New(PCoche,Init(97,93)));
  E^.Select;
End;

Procedure TZomInfo.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  SetColor(0);
  OutTextXY(P.X+53,P.Y+30,'XMini :');
  OutTextXY(P.X+53,P.Y+51,'XMaxi : ');
  OutTextXY(P.X+53,P.Y+72,'YMaxi : ');
  OutTextXY(P.X+9,P.Y+96,'Grille X : ');
  OutTextXY(P.X+139,P.Y+96,'Pas : ');
  DrawEnd;
End;

Procedure TZomInfo.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmOK     : ExitCode:=exOK;
      cmAnnule : ExitCode:=exAnnule;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

Procedure TApp.ZoomInfo;
Var R : TZoomRec;
    D : PZomInfo;
Begin
  R.XMin:=Zooms^.X1;
  R.XMax:=Zooms^.X2;
  R.YMax:=Zooms^.Y1;
  R.Pas:=Zooms^.Pas;
  R.Gril:=Zooms^.Gril;
  D:=New(PZomInfo,Init);
  D^.SetData(R);
  Insert(D);
  If D^.Exec=exOK Then
  Begin
    D^.GetData(R);
    Zoom(R.XMin,R.YMax,R.XMax,-R.YMax,R.Pas,R.Gril);
    WrkZone^.Draw;
  End;
  Dispose(D,Done);
End;

{ ---- Zoom Moins ---- }

Procedure TApp.ZoomMoins;
Begin
  UnZoom;
  WrkZone^.Draw;
End;

{ ====================== }
{   Outil de slection   }
{ ====================== }

Type PSelect  = ^TSelect;
     TSelect  = Object(TZoneDef)
                  Constructor Init(X,Y : Integer);
                  Procedure   WrkZoneDef(P1,P2 : TPoint);            Virtual;
                  Procedure   ElementClic(E : PObjet ; Var Event : TEvent);
                                                                     Virtual;
                End;

Constructor TSelect.Init(X,Y : Integer);
Begin
  inherited Init(X,Y,icPointer,cmInterdite,#27,#0,'Selection et dplacement','Echap');
  OutilAspect:=MouseCroix;
  HelpCtx:='Slection (Outil)';
End;

Procedure TSelect.WrkZoneDef(P1,P2 : TPoint);
Var X1,X2,Temp : Real;
    E          : PObjet;
Begin
  X1:=RX(P1.X);
  X2:=RX(P2.X);
  If X1>X2 Then Begin Temp:=X1; X1:=X2; X2:=Temp; End;
  E:=WrkZone^.Liste;
  While (E<>NIL) do
  Begin
    If (PElement(E)^.PosX>=X1) AND (PElement(E)^.PosX<=X2)
    Then
      Begin
        If (E^.Etat AND stSelected)=0 Then
        Begin
          E^.Etat:=E^.Etat OR stSelected;
          PElement(E)^.DrawSelect;
        End;
      End
    Else
      If (Toggle AND ToggleCtrl)=0 Then
        If (E^.Etat AND stSelected)<>0 Then
        Begin
          PElement(E)^.DrawSelect;
          E^.Etat:=E^.Etat AND (Not stSelected);
        End;
    E:=E^.Suiv;
  End;
End;

Procedure TSelect.ElementClic(E : PObjet ; Var Event : TEvent);
Var E1    : PObjet;
    X0    : Integer;
  Procedure Deplace;
  Begin
    Modif:=TRUE;
    Repeat
      GetMouseEvent(Event);
      StLine^.HandleEvent(Event);
      If Event.What=evMouseMove Then
      Begin
        E1:=WrkZone^.Liste;
        While E1<>NIL do
        Begin
          If (E1^.Etat AND stSelected)<>0 Then
          Begin
            PElement(E1)^.DrawSelect;
            E1^.Origin.X:=E1^.Origin.X+Event.Where.X-X0;
          End;
          E1:=E1^.Suiv;
        End;
        X0:=Event.Where.X;
        E1:=WrkZone^.Liste;
        While E1<>NIL do
        Begin
          If (E1^.Etat AND stSelected)<>0 Then PElement(E1)^.DrawSelect;
          E1:=E1^.Suiv;
        End;
      End;
    Until Event.What=evMouseLUp;
    E1:=WrkZone^.Liste;
    While (E1<>NIL) do
    Begin
      If (E1^.Etat AND stSelected)<>0 Then
        PElement(E1)^.PosX:=RX(E1^.Origin.X+WrkZone^.Origin.X+10);
      E1:=E1^.Suiv;
    End;
    WrkZone^.Draw;
    SetCommand(cmModif);
  End;
Begin
  X0:=MouseX;
  With PElement(E)^ do
    If (Etat AND stSelected)<>0
    Then
      Begin
        Repeat
          GetMouseEvent(Event);
        Until (Event.What=evMouseLUp) OR (Abs(MouseX-X0)>3);
        If Event.What=evMouseLUp Then
        Begin
          DrawSelect;
          Etat:=Etat AND (Not stSelected);
        End                      Else Deplace;
      End
    Else
      Begin
        If (Toggle AND ToggleCtrl)=0 Then
        Begin
          E1:=WrkZone^.Liste;
          While (E1<>NIL) do
          Begin
            If (E1^.Etat AND stSelected)<>0 Then
            Begin
              PElement(E1)^.DrawSelect;
              E1^.Etat:=E1^.Etat AND (Not stSelected);
            End;
            E1:=E1^.Suiv;
          End;
        End;
        Etat:=Etat OR stSelected;
        DrawSelect;
        Repeat
          GetMouseEvent(Event);
        Until (Event.What=evMouseLUp) OR (Abs(MouseX-X0)>3);
        If Abs(MouseX-X0)>3 Then Deplace;
      End;
  Event.What:=evNothing;
End;

{ ======================= }
{        POUBELLE         }
{ ======================= }

Var Poubel : Array[1..10] Of PObjet;
    IcPoub : PAction;

Type PPouInfo = ^TPouInfo;
     TPouInfo = Object(TDialog)
                  Selec : Array[1..10] Of Boolean;
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                  Procedure   DrawListe;
                  Procedure   DrawLigne(L : Byte);
                End;

Constructor TPouInfo.Init;
Var I : Byte;
Begin
  inherited Init(50,50,286,147,'Contenu de la poubelle');
  Ident:='DIA:POUBEL';
  HelpCtx:='Supprimer';
  Insert(New(PButton,Init(9,72,cmSuppr,'Dtruire',0,#8,#0)));
  Insert(New(PButton,Init(9,95,cmOK,'Sauver',btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(9,118,cmAnnule,'Fermer',btMotifEsc,#27,#0)));
  Insert(New(PIcone2,Init(9,26,9)));
  For I:=1 to 10 do Selec[I]:=FALSE;
End;

Procedure TPouInfo.DrawLigne(L : Byte);
Var V : Byte;
    Y : Integer;
    P : TPoint;
    S : String[10];
Begin
  DrawBegin;
  MakeGlobal(Origin,P);
  If Selec[L] Then SetFillStyle(SolidFill,15)
              Else SetFillStyle(SolidFill,7);
  SetColor(0);
  Y:=P.Y+23+L*10;
  Bar(P.X+97,Y-1,P.X+274,Y+7);
  If Poubel[L]<>NIL Then
  Begin
    Str(PElement(Poubel[L])^.PosX:8:2,S);
    V:=Pos('.',S);
    If V<>0 Then S[V]:=',';
    S:='X='+S;
    OutTextXY(P.X+102,Y,Poubel[L]^.Ident);
    OutTextXY(P.X+190,Y,S);
  End;
  DrawEnd;
End;

Procedure TPouInfo.DrawListe;
Var I : Byte;
Begin
  DrawBegin;
  For I:=1 to 10 do DrawLigne(I);
  DrawEnd;
End;

Procedure TPouInfo.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  OutLine(P.X+95,P.Y+26,182,112,8,0,7,15);
  DrawListe;
  DrawEnd;
End;

Procedure TPouInfo.HandleEvent(Var Event : TEvent);
Var P   : TPoint;
    I,N : Byte;
  Procedure DelPoub(R : Byte);
  Var I : Byte;
  Begin
    For I:=R to 9 do
    Begin
      Poubel[I]:=Poubel[I+1];
      Selec[I]:=Selec[I+1];
    End;
    Poubel[10]:=NIL;
    Selec[10]:=FALSE;
  End;
Begin
  inherited HandleEvent(Event);
  Case Event.What Of
    evCommand    : Begin
                     Case Event.Command Of
                       cmOK     : Begin
                                    Repeat
                                      N:=0;
                                      For I:=1 to 10 do
                                        If Selec[I] Then N:=I;
                                      If N<>0 Then
                                      Begin
                                        WrkZone^.Insert(Poubel[N]);
                                        DelPoub(N);
                                      End;
                                    Until N=0;
                                    ExitCode:=exOK;
                                  End;
                       cmSuppr  : Begin
                                    Repeat
                                      N:=0;
                                      For I:=1 to 10 do
                                        If Selec[I] Then N:=I;
                                      If N<>0 Then
                                      Begin
                                        Dispose(Poubel[N],Done);
                                        DelPoub(N);
                                      End;
                                    Until N=0;
                                    N:=0;
                                    For I:=1 to 10 do
                                      If Poubel[I]<>NIl Then Inc(N);
                                    If N=0 Then SetCommand(cmAnnule);
                                    DrawListe;
                                  End;
                       cmAnnule : ExitCode:=exAnnule;
                     Else
                       Exit;
                     End;
                     Event.What:=evNothing;
                   End;
    evMouseLDown : Begin
                     MakeGlobal(Origin,P);
                     If (Event.Where.X>=P.X+97) AND (Event.Where.X<=P.X+274) AND
                        (Event.Where.Y>=P.Y+33) AND (Event.Where.Y<=P.Y+132) Then
                     Begin
                       N:=((Event.Where.Y-P.Y-33) div 10)+1;
                       If Poubel[N]<>NIL Then
                       Begin
                         Selec[N]:=Not Selec[N];
                         DrawLigne(N);
                       End;
                     End;
                   End;
  End;
End;

Procedure TApp.Poubelle;
Var E      : PObjet;
    I,N,NG : Byte;
Begin
  { Compte le nombre d'lements  supprimer }
  E:=WrkZone^.Liste;
  N:=0;
  While (E<>NIL) do
  Begin
    If (E^.Etat AND stSelected)<>0 Then
      If (E^.Ident<>'Pupille') Then Inc(N);
    E:=E^.Suiv;
  End;
  If N=0 Then Exit;
  Modif:=TRUE;
  { On en gardera le maximum dans la poubelle }
  If N>10 Then NG:=10 Else NG:=N;
  N:=N-NG;
  { Libre le fond de la poubelle }
  For I:=11-NG to 10 do
    If Poubel[I]<>NIL Then Begin Dispose(Poubel[I],Done); Poubel[I]:=NIL; End;
  { Descends le dessus de la poubelle }
  For I:=10 DownTo NG+1 do
    Poubel[I]:=Poubel[I-NG];
  { Rcupre les nouveaux "dchts" }
  For I:=1 to NG do
  Begin
    E:=WrkZone^.Liste;
    While ((E^.Etat AND stSelected)=0) OR (E^.Ident='Pupille') Do E:=E^.Suiv;
    E^.Decroche;
    Poubel[I]:=E;
  End;
  { Et dtruit ceux qui ne peuvent tre gards }
  For I:=NG+1 to N do
  Begin
    E:=WrkZone^.Liste;
    While ((E^.Etat AND stSelected)=0) OR (E^.Ident='Pupille') Do E:=E^.Suiv;
    Dispose(E,Done);
  End;
  WrkZone^.Draw;
  IcPoub^.Dessin:=icPoubPleine;
  IcPoub^.Draw;
  IcPoub^.CommandR:=cmPoubInfo;
  SetCommand(cmModif);
End;

Procedure TApp.PoubInfo;
Var I : Byte;
Begin
  ExecObjet(New(PPouInfo,Init));
  WrkZone^.Draw;
  For I:=1 to 10 do
    If Poubel[I]<>NIL Then Exit;
  IcPoub^.Dessin:=icPoubVide;
  IcPoub^.Draw;
  IcPoub^.CommandR:=cmPoubInfo+cmInterdite;
End;

{ ============================ }
{  Routines gnrales de TApp  }
{ ============================ }

Procedure TApp.SetEvent(Event : TEvent);
Begin
  EventStock:=Event;
End;

Procedure TApp.GetEvent(Var Event : TEvent);
Begin
  If EventStock.What<>evNothing
  Then
    Begin
      Event:=EventStock;
      EventStock.What:=evNothing;
    End
  Else
    Begin
      GetMouseEvent(Event);
      If Event.What=evNothing Then
      Begin
        GetKeyboardEvent(Event);
        If Event.What=evNothing
        Then
          Begin
            GetTimeEvent(Event);
            If Event.What=evNothing Then Event.What:=evAuto;
          End
        Else
          If (Event.C1=#0) AND (Event.C2=#59) AND (Not InHelp) Then
          Begin
            ExecObjet(New(PHelpDia,Init));
            Event.What:=evNothing;
          End;
      End;
    End;
End;

Procedure TApp.Quit;
Begin
  If ExecObjet(New(PQuitte,Init))=exOK Then
    If VerifieModif Then ExitCode:=exOK;
End;

{ ====================== }
{    DEFINITION OBJET    }
{ ====================== }

Type PObjDef  = ^TObjDef;
     TObjDef  = Object(TDialog)
                  Constructor Init;
                  Procedure   Draw;                                  Virtual;
                  Procedure   HandleEvent(Var Event : TEvent);       Virtual;
                End;
     ObjetRec = Record
                  ObPosition : Real;
                  ObHauteur  : Real;
                  ObAngle    : Real;
                  PuDiametre : Real;
                  PuPosition : Real;
                  ObType     : Byte;
                End;

Constructor TObjDef.Init;
Var E : PReEdit;
    R : PRadio;
Begin
  inherited Init(50,50,364,226,'Paramtres de l''Objet et de la Pupille');
  Insert(New(PIcone2,Init(34,51,3)));
  E:=New(PReEdit,Init(217,52,15));
  Insert(E);
  Insert(New(PReEdit,Init(217,71,15)));
  Insert(New(PReEdit,Init(217,105,15)));
  Insert(New(PReEdit,Init(105,149,29)));
  Insert(New(PReEdit,Init(105,168,29)));
  Insert(New(PButton,Init(229,199,cmOK,    'OK',     btMotifEnter,#13,#0)));
  Insert(New(PButton,Init(277,199,cmAnnule,'Annuler',btMotifEsc  ,#27,#0)));
  R:=New(PRadio,Init);
  R^.Insert(New(PRadItem,Init(111,37)));
  R^.Insert(New(PRadItem,Init(111,90)));
  Insert(R);
  E^.Select;
End;

Procedure TObjDef.Draw;
Var P : TPoint;
Begin
  DrawBegin;
  inherited Draw;
  MakeGlobal(Origin,P);
  OutLine(P.X+103,P.Y+29,252,99,8,15,8,15);
  OutLine(P.X+8,P.Y+139,347,52,8,15,8,15);
  OutLine(P.X+16,P.Y+33,72,72,8,15,8,15);
  SetFillStyle(SolidFill,7);
  Bar(P.X+111,P.Y+26,P.X+158,P.Y+33);
  Bar(P.X+16,P.Y+136,P.X+79,P.Y+143);
  SetColor(0);
  OutTextXY(P.X+115,P.Y+26,'Objet');
  OutTextXY(P.X+20,P.Y+136,'Pupille');
  OutTextXY(P.X+129,P.Y+39,' Distance finie :');
    OutTextXY(P.X+129,P.Y+56,'Position :');
    OutTextXY(P.X+129,P.Y+75,'Hauteur  :');
  OutTextXY(P.X+129,P.Y+92,' l''infini :');
    OutTextXY(P.X+129,P.Y+109,'Angle   :');
  OutTextXY(P.X+17,P.Y+153,'Diamtre :');
  OutTextXY(P.X+17,P.Y+172,'Position :');
  DrawEnd;
End;

Procedure TObjDef.HandleEvent(Var Event : TEvent);
Begin
  inherited HandleEvent(Event);
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmOK     : ExitCode:=exOK;
      cmAnnule : ExitCode:=exAnnule;
    Else
      Exit;
    End;
    Event.What:=evNothing;
  End;
End;

Procedure TApp.ObjetDef;
Var D : PObjDef;
    R : ObjetRec;
Begin
  D:=New(PObjDef,Init);
  R.ObPosition:=Bougie^.PosX;
  R.ObHauteur:=Bougie^.Diam;
  R.ObAngle:=Bougie^.Angle*180/PI;
  R.ObType:=Bougie^.Tpe;
  R.PuDiametre:=Pupil^.Diam;
  R.PuPosition:=Pupil^.PosX;
  D^.SetData(R);
  Insert(D);
  If D^.Exec=exOK Then
  Begin
    D^.GetData(R);
    If R.ObType=1 Then
      If R.ObPosition>=R.PuPosition Then
        R.ObPosition:=R.PuPosition-10;
    Bougie^.PosX:=R.ObPosition;
    Bougie^.Diam:=R.ObHauteur;
    Bougie^.Angle:=R.ObAngle*PI/180;
    Bougie^.Tpe:=R.ObType;
    Pupil^.Diam:=R.PuDiametre;
    Pupil^.PosX:=R.PuPosition;
    WrkZone^.Draw;
  End;
  Dispose(D,Done);
End;

{ ==== Module : Analyse de la ligne de commande ==== }

Var ACharger : String;

Procedure LigneCommande;
Var I : Byte;
    S : String;
  Procedure CommandHelp;
  Begin
    Writeln('SoftOptique V1.0.     Avril-Mai 1993');
    Writeln;
    Writeln('Usage : Optique [NomFichier] [/?] [/P-] [/EGA] [/VGA]');
    Writeln('/help, /h, /? : Affiche cette aide');
    Writeln('/P-           : Pas de fentre de prsentation');
    Writeln('/EGA          : Force le mode graphique EGA');
    Writeln('/VGA          : Force le mode graphique VGA');
    Writeln;
    Halt;
  End;
  Procedure CommandError;
  Begin
    Writeln('Erreur dans les paramtres.');
    Writeln;
    Halt;
  End;
Begin
  NoPre:=FALSE;
  ACharger:='';
  For I:=1 to ParamCount do
  Begin
    S:=UpStr(ParamStr(I));
    If S[1]='/'
    Then
      Case S[2] Of
        'H'         : CommandHelp;
        '?'         : CommandHelp;
        'P'         : If S='/P-' Then NoPre:=TRUE Else CommandError;
        'E'         : If S='/EGA' Then ForceEGA:=TRUE Else CommandError;
        'V'         : If S='/VGA' Then ForceVGA:=TRUE Else CommandError;
      Else
        CommandError;
      End
    Else ACharger:=S;
  End;
End;